// eimpredDoc.cpp : implementation of the CEimpredDoc class
//

#include "stdafx.h"
#include "eimpred.h"
#include "eimpredDoc.h"
#include <io.h>
#include <stddef.h>
#include "MySys.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CEimpredDoc, CDocument)

BEGIN_MESSAGE_MAP(CEimpredDoc, CDocument)
	//{{AFX_MSG_MAP(CEimpredDoc)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CEimpredDoc::CEimpredDoc()
{
	// TODO: add one-time construction code here
	maploaded = false;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CEimpredDoc::~CEimpredDoc()
{
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BOOL CEimpredDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	OnOpenDocument( ProgaOpts->ProgDir+"default.mpr" );
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		//OnFileSave();
	}
	else
	{
		// TODO: add loading code here
	}
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
void CEimpredDoc::AssertValid() const
{
	CDocument::AssertValid();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BOOL CEimpredDoc::OnOpenDocument( LPCTSTR lpszPathName )
{
	// -  .

	//   ...
	ProgaOpts->MapFileName = lpszPathName;
	//  .      ...
	CDocument::OnOpenDocument( lpszPathName );
	ClearMprDirectory();
	chdir(ProgaOpts->ProgDir);
	chdir("mpr");
	pluginManager->SetNonePlugin();
	lInf =new LoadInfo;
	lInf->Create(NULL);
	lInf->ShowWindow( SW_SHOW );
	Log->AddLog( " :"+CString(lpszPathName), CLogFile::modeOk );

	CFile	df;
//////////////////////////////////
	if(!df.Open( lpszPathName, CFile::modeRead ))
	{
		CString s;
		s.Format( "%s  ", lpszPathName,CLogFile::modeFail );
		Log->AddLog( s.GetBuffer(0) );
	}
	else
	{
		CString s;
		s.Format( "%s ",lpszPathName);
		Log->AddLog( s.GetBuffer(0) );
		df.Close();
		progress(PT_MESSAGE,s.GetBuffer(0));
	}
	
//////////////////////////////////
	if( maploaded )
	{
		delete map;
	}
	CFile* file = new CFile( );
	if( !file->Open( lpszPathName, CFile::modeRead ) )
	{
		CString str;
		str.Format( "can not open %s file",lpszPathName );
		Log->AddLog( str,CLogFile::modeFail );
	}
	shortFileName =  file->GetFileName();
	Log->AddLog( "  :", CLogFile::modeOk );
	Log->AddLog( shortFileName, CLogFile::modeOk );

	delete file;
	if( !CopyFile( lpszPathName, "map.mpr",false ))
	{
		CString str;
		str.Format( "fail to copy %s file",lpszPathName );
		Log->AddLog( str,CLogFile::modeFail );
	
	};
	if( !CopyFile( ProgaOpts->ProgDir+"Files\\ResBuild.exe", "ResBuild.exe",false ) )
	{
		CString str;
		str.Format( "fail to copy ResBuild.exe" );
		Log->AddLog( str,CLogFile::modeFail );
	};
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW ;
	CString mapPath = "e ";
	mapPath += lpszPathName;
	mapPath += " *";
	progress(PT_MESSAGE,"  ");
	Log->AddLog( "  ", CLogFile::modeOk );
	CreateProcess( NULL, "resbuild.exe e map.mpr * ",  NULL, NULL, FALSE, 0, NULL, ProgaOpts->ProgDir + "\\mpr", &si, &pi );
	
	DWORD	result = STILL_ACTIVE;
	while( result == STILL_ACTIVE )
	{
		GetExitCodeProcess( pi.hProcess,&result);
	}
	Log->AddLog( " ", CLogFile::modeOk );
//////////////////////////////////
	//    ( *.mp-  )
	//   :).
	Log->AddLog( "   ...", CLogFile::modeOk );
	_finddata_t find_data;   //    ...
	long SearchHandle;  // ...
	SearchHandle = _findfirst(ProgaOpts->ProgDir+"\\mpr\\"+"*.mp",&find_data);
	if (SearchHandle == -1)
	{
		//  - :(.  :(.
		Log->AddLog( "   *.mp-    "+ProgaOpts->MapFileName, CLogFile::modeFail );
		exit(-1);
	};
	//CString Temp;
	//Temp = find_data.name;
	ProgaOpts->RealMapName = find_data.name;
	ProgaOpts->RealMapName.GetBufferSetLength( ProgaOpts->RealMapName.GetLength()-3 );
	ProgaOpts->RealMapName.MakeLower();
	Log->AddLog( " ()  : "+ProgaOpts->RealMapName, CLogFile::modeOk );

//////////////////////////////////
	if(!df.Open( ProgaOpts->GameDir + "\\res\\textures.res", CFile::modeRead ))
	{
		CString s;
		s.Format( "%sres\\textures.res  ",ProgaOpts->GameDir.GetBuffer(0),CLogFile::modeFail);
		Log->AddLog( s.GetBuffer(0) );
	}
	else
	{
		df.Close();
	}
	
//////////////////////////////////
	progress(PT_MESSAGE," ");
	Log->AddLog( " :", CLogFile::modeOk );
	CString s,d;
	d.Format( shortFileName );
	s.Format( "resbuild.exe e \"%sres\\textures.res\" %s???.mmp ",ProgaOpts->GameDir,ProgaOpts->RealMapName);
	Log->AddLog( s, CLogFile::modeOk );
	CreateProcess( NULL, s.GetBuffer(0),  NULL, NULL, FALSE, 0, NULL, ProgaOpts->ProgDir + "\mpr", &si, &pi );
	result = STILL_ACTIVE;
	while( result == STILL_ACTIVE )
	{
		GetExitCodeProcess( pi.hProcess,&result);
	}
	Log->AddLog( " ", CLogFile::modeOk );
	///////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////   .mp///////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	progress(PT_MESSAGE,"  (. mp)");
	Log->AddLog( "  (. mp)", CLogFile::modeOk );
	progress(PT_MESSAGE,"  ");
	Log->AddLog( "  ", CLogFile::modeOk );
	CString csSecFile = CString(shortFileName.GetBufferSetLength( shortFileName.GetLength() - 4 ));
	map = new CmprLandscape;
	map->Load(/* progress */);
	Log->AddLog( "  ", CLogFile::modeOk );
	maploaded = true;
	map->cam.z = map->tree->root->points[6].z*map->getvZoom()/65536.0f;
	lInf->ShowWindow( SW_HIDE );
	delete lInf;
	return true;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredDoc::OnCloseDocument()
{
	ClearMprDirectory();
	delete map;
	CDocument::OnCloseDocument();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredDoc::ClearMprDirectory()
{
	chdir(ProgaOpts->ProgDir);
	chdir("mpr");
	CString tmpdir;
	CFileFind finder;
	BOOL bWorking = finder.FindFile( "*.*" );
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		DeleteFile( finder.GetFilePath() );
	}
}

BOOL CEimpredDoc::OnSaveDocument( LPCTSTR lpszPathName ) 
{
	chdir( ProgaOpts->ProgDir );
	chdir( "mpr" );
	// TODO: Add your specialized code here and/or call the base class
	map->Save( ProgaOpts->RealMapName,ProgaOpts->GameDir,ProgaOpts->ProgDir );
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW ;
    ZeroMemory( &pi, sizeof(pi) );
	CString s;
	s.Format("ResBuild.exe a map.mpr *.sec *.mp");
	if(0 ==CreateProcess( NULL, s.GetBuffer(0),  NULL, NULL, FALSE, 0, NULL, ProgaOpts->ProgDir + "\mpr", &si, &pi ))
	{
		char buf[256];
		ZeroMemory(buf,256);
		FormatMessage(	FORMAT_MESSAGE_FROM_SYSTEM,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						buf,
						256,
						NULL);
		AfxMessageBox(buf);

	}
	DWORD	result = STILL_ACTIVE;
	while( result == STILL_ACTIVE )
	{
		GetExitCodeProcess( pi.hProcess,&result);
	}
	if(!CopyFile( "map.mpr",lpszPathName,FALSE ))
	{
		char buf[256];
		ZeroMemory(buf,256);
		FormatMessage(	FORMAT_MESSAGE_FROM_SYSTEM,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						buf,
						256,
						NULL);
		AfxMessageBox(buf);
	}
//	AfxMessageBox( EIgamedir + "\maps\\"+lpszPathName+".mpr" );
	return 1;
}

void CEimpredDoc::OnFileSave() 
{
	// TODO: Add your command handler code here
	OnSaveDocument(ProgaOpts->MapFileName);
}

void CEimpredDoc::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	//OnSaveDocument(ProgaOpts->MapFileName);
	OPENFILENAME ofstruct;
	char *Filters;
	CString FileName;
	//bool DialogResult;

	// ...
	Filters = new char[17];
	Filters = "Mpr-\0*.mpr\0\0";
	//    ...
	FileName.GetBufferSetLength(256);
	// ...
	ZeroMemory(&ofstruct,sizeof (OPENFILENAME)); 

	ofstruct.lStructSize = sizeof (OPENFILENAME);
	ofstruct.hwndOwner = ProgaOpts->PAppObject->m_pMainWnd->m_hWnd;
	ofstruct.lpstrFilter = Filters;
	ofstruct.nFilterIndex = 1;  // 1- ;
	ofstruct.lpstrFile = FileName.GetBuffer(0);
	ofstruct.nMaxFile = 256;
	ofstruct.lpstrInitialDir = ProgaOpts->LastDir;
	ofstruct.lpstrTitle = "  ?";
	ofstruct.lpstrDefExt = "mpr";
	
	if (GetSaveFileName(&ofstruct))
	{
		// . .
		OnSaveDocument(FileName);
		//   ...
	    ProgaOpts->LastDir = ExtractFilePath(FileName);
	    ProgaOpts->SaveOptsToIni();
	}
	else
	{
		//     ...
		/*char buf[256];
		ZeroMemory(buf,256);
		FormatMessage(	FORMAT_MESSAGE_FROM_SYSTEM,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						buf,
						256,
						NULL);
		AfxMessageBox(buf);*/
		//AfxMessageBox("");
	};
};

void CEimpredDoc::OnFileOpen() 
{
	// TODO: Add your command handler code here
	//OnSaveDocument(ProgaOpts->MapFileName);
	OPENFILENAME ofstruct;
	char *Filters;
	CString FileName;
	//bool DialogResult;

	// ...
	Filters = new char[17];
	Filters = "Mpr-\0*.mpr\0\0";
	//    ...
	FileName.GetBufferSetLength(256);
	// ...
	ZeroMemory(&ofstruct,sizeof (OPENFILENAME)); 

	ofstruct.lStructSize = sizeof (OPENFILENAME);
	ofstruct.hwndOwner = ProgaOpts->PAppObject->m_pMainWnd->m_hWnd;
	ofstruct.lpstrFilter = Filters;
	ofstruct.nFilterIndex = 1;  // 1- ;
	ofstruct.lpstrFile = FileName.GetBuffer(0);
	ofstruct.nMaxFile = 256;
	ofstruct.lpstrInitialDir = ProgaOpts->LastDir;
	ofstruct.lpstrTitle = "     ?";
	ofstruct.lpstrDefExt = "mpr";
	ofstruct.Flags = OFN_FILEMUSTEXIST;
	
	if (GetOpenFileName(&ofstruct))
	{
		// . .
		OnOpenDocument(FileName);
		//   ...
	    ProgaOpts->LastDir = ExtractFilePath(FileName);
	    ProgaOpts->SaveOptsToIni();
	}
	else
	{
		//     ...
		/*char buf[256];
		ZeroMemory(buf,256);
		FormatMessage(	FORMAT_MESSAGE_FROM_SYSTEM,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						buf,
						256,
						NULL);
		AfxMessageBox(buf);*/
		//AfxMessageBox("");
	};
};