// LightModel.cpp: implementation of the CLightModel class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "eimpred.h"
#include "LightModel.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLightModel::CLightModel()
{
	loaded = false;
}

CLightModel::~CLightModel()
{

}

bool CLightModel::Load( CString file )
{
	loaded = true;
	CString time;
	TCHAR a[256];
	for( int i=0;i<24;i++ )
	{
		time.Format("time%02d",i);
		if( 0 == GetPrivateProfileString( "sunlight", time, "default", a, 256, file ) )
		{
			loaded = false;
			return false;
		}
		sscanf( a, "%d,%d,%d",&sunlight[i].r,&sunlight[i].g,&sunlight[i].b );
		if( 0 == GetPrivateProfileString( "ambient", time, "default", a, 256, file ) )
		{
			loaded = false;
			return false;
		}
		sscanf( a, "%d,%d,%d",&ambient[i].r,&ambient[i].g,&ambient[i].b );
		if( 0 == GetPrivateProfileString( "sky", time, "default", a, 256, file ) )
		{
			loaded = false;
			return false;
		}
		sscanf( a, "%d,%d,%d",&sky[i].r,&sky[i].g,&sky[i].b );
	}
	return true;
}
