//        ....
#include "MySys.h"
//#include <stdlib.h>
//#include <windows.h>
//#include <shlwapi.h>
#include "stdafx.h"

#define _CVTBUFSIZE (309+40) /* # of digits in max. dp value + slop */

//#include <>

CString Parse(CString *S, CString Separators)
// .
{
	//
	CString Result;
	int Pos;

	//...
	Pos = S->FindOneOf(Separators);
	if (Pos <= 0) Pos = S->GetLength() + 1;
	Result = *S;
	*S = Result.Mid(Pos+1,Result.GetLength()-Pos);
	Result = Result.Mid(0, Pos );
	//*S = S->Mid(0, Pos );
	//Result = *S;
	

	// ...
	return Result;
};

bool DirectoryExists(CString Name)
//    .
{
	int Code;
	bool Result;

	Code = GetFileAttributes(Name);
	Result = ((Code != -1) && ((FILE_ATTRIBUTE_DIRECTORY & Code) != 0));

	return Result;
};


CString IntToStr(int Int1)
//    .
{
	CString Result;
	char *buffer;
	
	buffer = new char[256];
	buffer = itoa(Int1,buffer,10);

	Result = buffer;
	delete buffer;
	return Result;
};

CString FloatToStr(double Flt1)
//   .
{
	//...
	CString Result;
	char *buffer;//, *temp;
	//int  decimal, sign, i;

	//  .
	buffer = new char[_CVTBUFSIZE];
	buffer = _gcvt(Flt1,12,buffer);

	// 
	Result = buffer;
	delete buffer;
	return Result;
};

int GetLastDelimIndex(CString Str, char delim)
//   
{
	int Result = -1, i = -1;

	do
	{
		i = i+1;  // .
		if (Str.GetAt(i) == delim)
		{
			//     :).
			Result = i;
		};
	}
	while (i < Str.GetLength()-1);

	return Result;
};

CString ExtractFilePath(CString FullFileName)
//    .
{
	int LastDelimIndex;
	CString Result;

	LastDelimIndex = GetLastDelimIndex(FullFileName,'\\');

	
	if (LastDelimIndex != -1)
	{
		//        ...
		Result.GetBufferSetLength(LastDelimIndex+1);
		memcpy(Result.GetBuffer(0),FullFileName.GetBuffer(0),LastDelimIndex+1);
	}
	else
	{
		//   .
		Result = FullFileName;
	};

	return Result;
};

CString AddExtIfNoExt(CString FullFileName, CString Ext)
//    ,   .
{
	CString Result;
	int LastDelimIndex;

	//   ...
	LastDelimIndex = GetLastDelimIndex(FullFileName,'.');

	if (LastDelimIndex != -1)
	{
		//   -    .
		Result = FullFileName;
	}
	else
	{
		//  .  .
		Result = FullFileName+Ext;
	};

	// .
	return Result;
};     

void ClearDir(CString Path, bool Delete)
//     .
{
	//
	const int faArchive = 0x00000020;
	//
	HANDLE FindHandle;
	WIN32_FIND_DATA FindData;
	CString FNam, DirList = "", FileList = "";
	bool Bool1;//, Bool2;

	//    .
	FindData.dwFileAttributes = FILE_ATTRIBUTE_NORMAL;
	FindHandle = FindFirstFile(Path+"*.*",&FindData);
	if (FindHandle != INVALID_HANDLE_VALUE)
	{
		Bool1 = true;
		do
		{
			FNam = FindData.cFileName;
			if ((FNam != "..") && (FNam != "."))
			{
				if (DirectoryExists(Path+FNam))
				{
					DirList = DirList+FNam+"|";
				}
				else
				{
					FileList = FileList+FNam+"|";
				};
			};
			Bool1 = (FindNextFile(FindHandle,&FindData)!=0);
		} while (Bool1);
		FindClose(FindHandle);
	};

	//  .
	if (FileList != "")
	{
		do
		{
			FNam = Path+CString(Parse(&FileList,"|"));
			if (PathFileExists(FNam))
			{
				SetFileAttributes(FNam,faArchive);
				DeleteFile(FNam);
			};
		} while (FileList != "");
	};

	//   ().
	if (DirList != "")
	{
		do
		{
			FNam = Path+CString(Parse(&DirList,"|")+"\\");
			if (PathFileExists(FNam))
			{
				SetFileAttributes(FNam,faArchive);
				ClearDir(FNam,true);
			};
		}
		while (DirList != "");
	};  

	//  -   .
	if (Delete)
	{
		if (PathFileExists(Path))
		{
			RemoveDirectory(Path);
		};
	};
};
