#include "PluginsToolBar.h"

#if !defined(AFX_PLUGINMANAGER1_H__7B01823A_F2C4_48B7_A126_A60D59E69233__INCLUDED_)
#define AFX_PLUGINMANAGER1_H__7B01823A_F2C4_48B7_A126_A60D59E69233__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PluginManager1.h : header file
//
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CPluginManager1 window

class CPluginManager
{
// Construction
public:
	CPluginManager();

// Attributes
protected:
	unsigned int pCameraCount,pGeometryStageCount,pTextureStageCount;
public:
	CPluginsToolBar	pCamera;
	CPluginsToolBar	pGeometryStage;
	CPluginsToolBar	pTextureStage;

// Operations
public:
	void LoadPluginsGroup( CPluginsToolBar*,CString,UINT,unsigned int,CFrameWnd*,UINT );
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPluginManager1)
	//}}AFX_VIRTUAL

// Implementation
public:
	CPlugin* LoadPlugin( CString );
	BOOL Create( CFrameWnd* pParentWnd, CWnd* firstToolBar );
	~CPluginManager();
	void SetActiveCameraPlugin( int );
	void SetActiveGeometryPlugin( int );
	void SetActiveTSPlugin( int );
	void SetNonePlugin();
	// Generated message map functions
protected:
	//{{AFX_MSG(CPluginManager1)
	//}}AFX_MSG

};
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLUGINMANAGER1_H__7B01823A_F2C4_48B7_A126_A60D59E69233__INCLUDED_)
