class CTitle
{
public:
	byte A, B, C, D;
	int Number;
	bool operator == (CTitle X)
	{
		return ((X.A == A) && (X.B == B) && (X.C == C) && (X.D == D));
	}

	CTitle& operator =(const CTitle X)
	{
		A = X.A;
		B = X.B;
		C = X.C;
		D = X.D;
		return *this;
	}

	CTitle(byte a=0, byte b=0, byte c=0, byte d=0)
	{
		A = a;
		B = b;
		C = c;
		D = d;
		Number = 0;
	}
	CTitle(const CTitle *a)
	{
		A = a->A;
		B = a->A;
		C = a->C;
		D = a->D;
		Number = a->Number;
	}

	CTitle& Rotate()
	{
		CTitle Tmp = *this;
		A = Tmp.C;
		B = Tmp.A;
		C = Tmp.D;
		D = Tmp.B;
		return *this;
	}

	CString ToString()
	{
		CString Rez="";
		Rez.Format("%d,%d\r\n%d,%d",A,B,C,D);
		return Rez;
	}
};