#include "stdafx.h"
#if !defined (_CCAMERA_)
#define       _CCAMERA_
class MPRBASE_API Camera  : public vec3
{
public:
	float HA,VA,YA;
	quat	cView;
	vec3	pos;
	mat4	mv;
public: 
	void Clear();
	Camera();
	Camera( float,float,float,float,float,float);
	~Camera();
	void RotateH( float angle );
	void RotateV( float angle );
	void RotateY( float angle );
	void Slide(	 float direction );
	void Fly( float direction );
	void MoveAndRotate();
	bool ShowRect;
	quat GetCameraQuat();
};

#endif