// LogFile.cpp: implementation of the CLogFile class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "LogFile.h"
#include <direct.h>
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

MPRBASE_API	CLogFile*	Log;
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CLogFile::CLogFile( )
{
	char a[255];
	getcwd(a,255);
	filePath.Format( "%s\\log.txt",a );
	file = fopen( filePath, "w" );
	time_t ltime;
	time( &ltime );
	fprintf( file, ctime( &ltime ) );
	fprintf( file, "\n" );
	fclose( file );
	if( !file ) 
	{
		AfxMessageBox("error creating log file");
		exit(-1);
	}
//	CFile();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CLogFile::~CLogFile()
{
	fclose( file );

}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CLogFile::AddLog( char* str, Failure msType)
{
	file = fopen( filePath, "a+" );
	fwrite( str, 1,strlen(str),file );
	fwrite( "\n", 1,1,file );
	if( msType == modeFail )
	{
		AfxMessageBox( "Something wrong. See log.txt" );
		fclose( file );
		exit(-1);
	}
	fclose( file );
}

void CLogFile::AddLog( CString str, Failure msType)
{
	AddLog( str.GetBuffer(0), msType );
}
