// CMPHeader.h: interface for the CMPHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CMPHEADER_H__C0E782F0_8D2E_4F31_B21D_1681E72AE4BE__INCLUDED_)
#define AFX_CMPHEADER_H__C0E782F0_8D2E_4F31_B21D_1681E72AE4BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class MPRBASE_API CMPHeader  
{
public:
	void Read();
	CMPHeader();
	~CMPHeader();

	DWORD dwSignature;							// Map file signature
	float fpMaxZ;								// Max Z value of the map
	DWORD dwXSectorsCount;						// Numbers of sectors
	DWORD dwYSectorsCount;
	DWORD dwTextures;							// Number of textures in map
	DWORD dwTexSize;							// Size of the texture
	DWORD dwTiles;								// Number of tiles in map
	DWORD dwTileSize;							// Size of tile
	WORD wObjectsCount;							// Number of objects in the map
	DWORD dwAnimatedTiles;						// Number of animated tiles indexes
	SMapObject*	objectArray;  // Array of objects descriptions
	int*	idArray;			// Terrian type ID's
	STileAnimInfo*	animArray;// Tile animation info

public:
	CString	cFileName;

};

#endif // !defined(AFX_CMPHEADER_H__C0E782F0_8D2E_4F31_B21D_1681E72AE4BE__INCLUDED_)
