#if !defined(AFX_MATERIALDLG_H__D788D6CF_9A61_4C1D_AD53_4A30E1BEF09C__INCLUDED_)
#define AFX_MATERIALDLG_H__D788D6CF_9A61_4C1D_AD53_4A30E1BEF09C__INCLUDED_

#include "resource.h"
#include "afxwin.h"
//#include "CPresetEditor.h"

#define	TITLE_MAP_SIZE		256
#define	SINGLE_TITLE_SIZE	32

#define FROM 1
#define TO 0

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MaterialDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CMaterialDlg dialog

class MPRBASE_API CMaterialDlg : public CDialog
{
public:
	void showTitleBig();
	void changeTexImage( int );
	int GetTexCount()
	{
		int t = m_TexSlider.GetRangeMax();
		return t;
		//return texMan->texCount;
	}
	CMaterialDlg(CWnd* pParent = NULL);   // standard constructor
	unsigned int		getCurrentTitle(){ return currentTitle; };
	void setCurrentTitle(unsigned int New)
	{
		currentTitle=New;
	}
	rgb*		img;
	CBitmap		hbmScreen,bmTitle;
	CDC			dcMem, dcTitleMem,	*hdcScreen;
	bool		execute();
//////////////////////////////////////////
//Zap_Editor_Class////////////////////////
//////////////////////////////////////////
private:
	byte *buf;
	WORD ZapCount;
	byte MatCount;
	int BufLength;
	int SavedTile;
public:
	void GenerateOpt();
	int StrToInt(CString s);
	void LoadBuf(const CString Path);
	void SaveBuf(const CString Path);
    CString GetCaption(const byte Num);
	int GetCode(const byte Num);
    void SetCode(const byte Num, const byte Code);
	void SetCaption(const byte Num, const CString Name);

	byte *GetZap(const int Num);
	void SetZap(const int Num, const byte *Zap);

	void FillTileForm(int num);
	void FillMatList();

	byte* AddMat(byte *Buffer, int *Len, byte MatCod, CString Name);
	byte* DelMat(byte *Buffer, int *Len, byte MatNum);
	void AddTile(const byte *Buffer, byte *Dest, int *Len, byte *Tile);
	//Tiles...

	byte GetMatCount()
	{
		return MatCount;
	}
    //-------------------------
	WORD GetZapCount()
	{
		return ZapCount;
	}
// Dialog Data
	//{{AFX_DATA(CMaterialDialog)
	enum { IDD = IDD_MATERIAL_DIALOG };
	CSliderCtrl	m_TexSlider;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMaterialDialog)
	public:
	virtual BOOL Create( CWnd* pParentWnd );
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd* pParentWnd;
	unsigned int currentTex,currentTitle,tmp;
	CPoint	pos,clk;
	// Generated message map functions
	//{{AFX_MSG(CMaterialDlg)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnReleasedcaptureTexSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CString MatName;
	CString MatCode;
//    CTexPreset tOpt;
	CString optPath;
	bool pInited;
	CString Tile_a;
	CString Tile_b;
	CString Tile_c;
	CString Tile_d;
	~CMaterialDlg()
	{
		//if(BufLength>0)delete [] buf;
	}
	afx_msg void OnBnClickedSaveOpts();
	afx_msg void OnBnClickedTestbutton();
	afx_msg void OnBnClickedGenerateOpts();
	CListBox MList;
	afx_msg void OnBnClickedAddMat();
	afx_msg void OnBnClickedApplyMat();
	afx_msg void OnBnClickedApplyTile();
	afx_msg void OnBnClickedKillMat();
	afx_msg void OnLbnSelchangeMatList();
	afx_msg void OnBnClickedPushTile();
	afx_msg void OnBnClickedCallTile();
	afx_msg void OnBnClickedOk();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MATERIALDLG_H__D788D6CF_9A61_4C1D_AD53_4A30E1BEF09C__INCLUDED_)
