// ResManager.h: interface for the CResManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RESMANAGER_H__0060E5C6_B403_43CE_95AE_74512D48566E__INCLUDED_)
#define AFX_RESMANAGER_H__0060E5C6_B403_43CE_95AE_74512D48566E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//   Res 
struct SResHeader
{

	DWORD dwSignature;
	DWORD dwNumFile;
	DWORD dwDataSize;
	DWORD dwStrSize;

};

//   Res
struct SIndex
{

	DWORD dwSignature;
	DWORD dwFileSize;
	DWORD dwFilePos;
	DWORD dwSignature2;
	WORD  wFileNameSize;
	DWORD dwFileNamePos;

};



class MPRBASE_API CResManager  
{
public:
	CResManager();
	virtual ~CResManager();

	void SetPathRes(CString sPathRes)	{ this->sPathRes = sPathRes; }				//    Res 
	CString GetPathRes()				{ return sPathRes; }						// 
	CString GetFileNames()				{ return sFileNames; }						//
	DWORD GetNumFile()					{ return hdr.dwNumFile; }					//      Res
	WORD GetFileNameSize(DWORD ind)     { return pSIndex[ind].wFileNameSize; }		//        
	DWORD GetFileNamePos(DWORD ind)     { return pSIndex[ind].dwFileNamePos; }		//         Res   
	CString GetFileName(DWORD pos, WORD size) { return sFileNames.Mid(pos, size);}  //      

	CFile *Open(CString sNameFileRes);		// open res file
	BOOL Load(CFile *pFile);				// load res file	
	BOOL Load(CString sNameFileRes);		// load res file
	BOOL Load(LPBYTE lpData);				//  Res         Res, mpr 

	BYTE *Get(CString sNameFile, BOOL b);	// get file in res	False -  , True -  

	//    Res     ,    
	BOOL Get(CString sNameFile, DWORD &dwFilePos, DWORD &dwFileSize);
	
protected:	
	CFile *Open();

	
//	CFile *pFile;

public:
	SResHeader	hdr;
	BYTE		*pData;
	SIndex		*pSIndex;
	CString		sFileNames;
	CString		sPathRes;
	CString		sNameFileRes;

};

#endif // !defined(AFX_RESMANAGER_H__0060E5C6_B403_43CE_95AE_74512D48566E__INCLUDED_)


/*

1)	   SetPathRes(CString sPathRes)    
	 	SetPathRes(_T("D:\\Games\\ \\Res\\"));

2)      Res      
	Load(CFile *pFile);				// load res file	
	Load(_T("textures.res"));		// load res file

3) 	 BYTE *Get(CString sNameFile);       
	
	 BOOL Get(CString sNameFile, DWORD &dwFilePos, DWORD &dwFileSize);
	      Res   .

*/
extern MPRBASE_API CResManager *resMan;