// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__C8DC7259_9ADB_475A_914C_AA084AF088AF__INCLUDED_)
#define AFX_STDAFX_H__C8DC7259_9ADB_475A_914C_AA084AF088AF__INCLUDED_

#ifdef MPRBASE_EXPORTS
#define MPRBASE_API __declspec(dllexport)
#else
#define MPRBASE_API __declspec(dllimport)
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions

#ifndef _AFX_NO_OLE_SUPPORT
#include <afxole.h>         // MFC OLE classes
#include <afxodlgs.h>       // MFC OLE dialog classes
#include <afxdisp.h>        // MFC Automation classes
#endif // _AFX_NO_OLE_SUPPORT


#ifndef _AFX_NO_DB_SUPPORT
#include <afxdb.h>			// MFC ODBC database classes
#endif // _AFX_NO_DB_SUPPORT

#ifndef _AFX_NO_DAO_SUPPORT
#include <afxdao.h>			// MFC DAO database classes
#endif // _AFX_NO_DAO_SUPPORT

#include <afxdtctl.h>		// MFC support for Internet Explorer 4 Common Controls
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#pragma comment(lib,"opengl32.lib")
#pragma comment(lib,"glu32.lib")
#pragma comment(lib,"glew32.lib")
#pragma warning( disable:4129 )
// Insert your headers here
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <Math.h>
#include <AfxWin.h>
#include <gl\glew.h>
#include <gl\gl.h>
#include "gametypes.h"
#include <direct.h>
#include <map>
#include "..\OptionsManager.h"

#define Dot3(a,b) (a[0]*b.x+a[1]*b.y+a[2]*b.z*map->getvZoom()/65536.0f)

extern plane_t frustum[6];
extern float proj[16]; //  
extern float view[16]; //  
extern float  clip[16]; //   
extern int	count;
extern	CView*	_View;

#pragma warning( disable : 4091 )
extern	class CLogFile;
#pragma warning( default : 4091 )
// TODO: reference additional headers your program requires here
void MPRBASE_API setLog( CLogFile* );

enum	ProgressTypes
{
	PT_SET_TITLE_COUNT,
	PT_LOAD_TITLE,
	PT_SET_SECTION_COUNT,
	PT_LOAD_SECTION,
	PT_MESSAGE
};

//extern	CString  MPRBASE_API MapName;
extern	COptManager MPRBASE_API *ProgaOpts;

typedef void (CALLBACK * prgProc) ( ProgressTypes	type,void*	data ); 
//vertex crossproduct( vertex a,vertex b );
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__C8DC7259_9ADB_475A_914C_AA084AF088AF__INCLUDED_)
