///////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////
/*
:
   -  ,    Delete()   .

   */

/* 
UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
*/
#include "stdafx.h"
#include "resource.h"
#include "Ccamedit.h"
#include <EIplugin\cplugin_base.h>

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif
#include "resource.h"
#include "..\MySys.h"
#include ".\ccamedit.h"
Ccamedit	plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog


Ccamedit::Ccamedit()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CPlugin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void Ccamedit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlugin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

void Ccamedit::Create( CWnd* pParentWnd )
{
	CDialog::Create( Ccamedit::IDD, pParentWnd );
	//PluginWindowHandle = pParentWnd->m_hWnd;
	handle = pParentWnd;
	icon = AfxGetApp()->LoadIcon( IDI_ICON1 );
	tip = "Move";
	oldLPos.x = 0;
	oldLPos.y = 0;
	oldLPos.z = 0;
	oldLPos.x = 0;
	oldLPos.y = 0;
	oldLPos.z = 0;
//  
	CString Path = ProgaOpts->ProgDir+"\mainmenu.cam";
	Path.GetBufferSetLength(256);
	DWORD PL = GetPrivateProfileString("MainOptions","LastCamPath",ProgaOpts->ProgDir+"\mainmenu.cam",Path.GetBuffer(0),256,ProgaOpts->ProgDir + IniName);

	SetDlgItemText(IDC_FILEPATH,Path);
    SetDlgItemText(IDC_FROM_1,"0");
	SetDlgItemText(IDC_TO_1,"0");
    SetDlgItemText(IDC_FROM_2,"0");
	SetDlgItemText(IDC_TO_2,"0");
}

BEGIN_MESSAGE_MAP(Ccamedit, CDialog)
	//{{AFX_MSG_MAP(CPlugin)
	ON_BN_CLICKED(IDC_BTN_EXPORT, ExportZap)
	ON_BN_CLICKED(IDC_BTN_IMPORT, ImportZap)
	ON_BN_CLICKED(IDC_BTN_OPEN, LoadFile)
	ON_BN_CLICKED(IDC_BTN_SAVE, SaveFile)
	ON_BN_CLICKED(IDC_BTN_SET, SetView)
	ON_BN_CLICKED(IDC_BTN_SHOW, ShowView)
	ON_BN_CLICKED(IDC_BTN_PLAY, PlayFile)
	ON_BN_CLICKED(IDC_BTN_TEST, Test)
	ON_BN_CLICKED(IDC_BTN_APPLY, Apply)
	ON_BN_CLICKED(IDC_BTN_PREV, ShowPrev)
	ON_BN_CLICKED(IDC_BTN_NEXT, ShowNext)
	ON_BN_CLICKED(IDC_BTN_NEW, NewZap)
	ON_BN_CLICKED(IDC_BTN_KILL, RemoveZap)
	ON_BN_CLICKED(IDC_BTN_OFFSET, BtnOffset)
	//}}AFX_MSG_MAP
	ON_STN_CLICKED(IDC_QuatXSt, OnStnClickedQuatxst)
	ON_BN_CLICKED(IDC_INVERSE, OnBnClickedInverse)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_EXTENDED, OnBnClickedBtnExtended)
	ON_BN_CLICKED(IDC_BTN_DEL, OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_SAVE_COORDS, OnBnClickedSaveCoords)
	ON_BN_CLICKED(IDC_SAVE_VIEW, OnBnClickedSaveView)
	ON_BN_CLICKED(IDC_BTN_SWAP, OnBnClickedBtnSwap)
	ON_BN_CLICKED(IDC_BTN_INVERCE, OnBnClickedBtnInverce)
	ON_BN_CLICKED(IDC_BTN_MOVE, OnBnClickedBtnMove)
	ON_BN_CLICKED(IDC_BTN_ROTATE, OnBnClickedBtnRotate)
	ON_BN_CLICKED(IDC_BTN_POINT_LOOK, OnBnClickedBtnPointLook)
	ON_BN_CLICKED(IDC_BTN_TRACK, OnBnClickedBtnTrack)
	ON_BN_CLICKED(IDC_BTN_TIME, OnBnClickedBtnTime)
END_MESSAGE_MAP()


void Ccamedit::onMouseMove    ( UINT nFlags, CPoint point )
{
	//  .
	if( nFlags & MK_LBUTTON )
	{
		//   -     .	
		vec3 t1,t2,v;
		float temp;
		
		v = map->selectionRay( nFlags, point );
		
		temp = -map->cam.z/v.z;

		t2.x = map->cam.x + temp*v.x;
		t2.y = map->cam.y + temp*v.y;
		t2.z = map->cam.z + temp*v.z;

		v.x = oldLPos.x - map->cam.x;
		v.y = oldLPos.y - map->cam.y;
		v.z = oldLPos.z - map->cam.z;

		temp = -map->cam.z/v.z;
		t1.x = map->cam.x + temp*v.x;
		t1.y = map->cam.y + temp*v.y;
		t1.z = map->cam.z + temp*v.z;
		map->cam.x += (float)( oldLPos.x - t2.x );
		map->cam.y += (float)( oldLPos.y - t2.y );

		//   -    .
		SetDlgItemText(IDC_XCamCoordSt,FloatToStr(map->cam.x));
		SetDlgItemText(IDC_YCamCoordSt,FloatToStr(map->cam.y));
	}
	if( nFlags & MK_RBUTTON )
	{
		CPoint offset  = point - start;
		HA = (float)offset.x/5.0f; //Z
		VA = (float)offset.y/5.0f; //X
		YA = (float)offset.x/5.0f; //Y
		if( !GetAsyncKeyState( VK_SHIFT ) )
		  map->cam.RotateH( HA );
		if( !GetAsyncKeyState( VK_CONTROL ) )
		{
		  if(!GetAsyncKeyState( VK_MENU ))
		  {
		  	 map->cam.RotateV( VA );
		  }
		  else
		  {
		     map->cam.RotateY( YA );
		  }
		}
			 
		/////////////////////////////////////////////////////////
		glPushMatrix();
		glLoadIdentity();
		mat4 mrx/*,mry*/,mrz,mt,mv;
		mrx.rotation_x( map->cam.VA );
		//mry.rotation_y( map->cam.YA );
		mrz.rotation_z( map->cam.HA );
		mt.translate( -map->cam.x,-map->cam.y,-map->cam.z );
		mv = mrx/**mry*/*mrz*mt;
		glMultMatrixf(&mv[0]);

		CPoint	qpoint;
		GLint	vp[4];
		glGetIntegerv(GL_VIEWPORT,vp);
		qpoint.x = vp[2]/2;
		qpoint.y = vp[3]/2;
		vec3 v = map->selectionRay( nFlags, qpoint );
		v.normalize();
		glPopMatrix();

		vec3 ep1;
		ep1.x = map->cam.x + v.x*len;
		ep1.y = map->cam.y + v.y*len;
		ep1.z = map->cam.z + v.z*len;

		vec3 offs = ep1 - sp;

/////////////////////////////////////////////////////////
		start = point;
		map->cam.x -= offs.x;
		map->cam.y -= offs.y;
		map->cam.z -= offs.z;
		//   -    .
		SetDlgItemText(IDC_HACamSt,FloatToStr(map->cam.HA));
		SetDlgItemText(IDC_VACamSt,FloatToStr(map->cam.VA));
		SetDlgItemText(IDC_YACamSt,FloatToStr(map->cam.YA));
		SetDlgItemText(IDC_QuatXSt,FloatToStr(map->cam.GetCameraQuat().x));
		SetDlgItemText(IDC_QuatYSt,FloatToStr(map->cam.GetCameraQuat().y));
		SetDlgItemText(IDC_QuatZSt,FloatToStr(map->cam.GetCameraQuat().z));
		SetDlgItemText(IDC_QuatWSt,FloatToStr(map->cam.GetCameraQuat().w));
	}
};
void Ccamedit::onRButtonDown  ( UINT nFlags, CPoint point )
{
	GLint	vp[4];
	glGetIntegerv(GL_VIEWPORT,vp);
	start = point;
	point.x = vp[2]/2;
	point.y = vp[3]/2;
	vec3 v = map->selectionRay( nFlags, point );
	sp = map->findSelect( v );
	view = sp - vec3( map->cam.x,map->cam.y,map->cam.z );
	len = (vec3( map->cam.x,map->cam.y,map->cam.z ) - sp).length();
};

void Ccamedit::onLButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 v;
	float t;

	v = map->selectionRay( nFlags, point );
	t =	-map->cam.z/v.z;
	oldLPos.x = map->cam.x + t*v.x;
	oldLPos.y = map->cam.y + t*v.y;
	oldLPos.z = map->cam.z + t*v.z;


};
void Ccamedit::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void Ccamedit::onRButtonDblClk( UINT nFlags, CPoint point )
{
};

/////////////////////////////////////////////////////////////////////////////
// CPlugin message handlers
CPlugin*	getPlugin( )
{
	return (Ccamedit*)(&plugin);
}

void Ccamedit::onPluginSelect()
{
	map->cam.ShowRect = true;
}

void Ccamedit::onPluginUnSelect()
{
	map->cam.ShowRect = false;
}

void Ccamedit::ExportZap()
{
//Exports a camera record
	FILE *file;
	CString filePath,tmp;

	filePath.Format("%s\\export1.txt",ProgaOpts->ProgDir);


	file = fopen(filePath,"w");
//         X
	tmp = FloatToStr(map->cam.x);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Y
	tmp = FloatToStr(map->cam.y);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Z
	tmp = FloatToStr(map->cam.z);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Qw
	tmp = FloatToStr(map->cam.GetCameraQuat().w);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Qx
	tmp = FloatToStr(map->cam.GetCameraQuat().x);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Qy
	tmp = FloatToStr(map->cam.GetCameraQuat().y);
	fprintf(file,tmp);
	fprintf(file,"\r\n");
//         Qz
	tmp = FloatToStr(map->cam.GetCameraQuat().z);
	fprintf(file,tmp);
	fprintf(file,"\r\n");

	fclose(file);
	MessageBox(("Record exported to \r\n %s",filePath));
}

void Ccamedit::ImportZap()
{
//     ,   
	FILE *file;
	CString filePath;
	byte *buf;
	int len;

	filePath.Format("%s\\export2.txt",ProgaOpts->ProgDir);

	file = fopen(filePath,"r");
    if(file)
	{	 
	  fseek(file,0,SEEK_END);
	  len = ftell(file);
	  buf = new byte[len];
	  fseek(file,0,SEEK_SET);
	  fread(buf,len,1,file);
      fclose(file);
// ...
      float f=0;

	  memcpy(&f,buf,4);
	  map->cam.x = f;
	  SetDlgItemText(IDC_XCamCoordSt,FloatToStr(f));

	  memcpy(&f,buf+4,4);
	  map->cam.y = f;
	  SetDlgItemText(IDC_YCamCoordSt,FloatToStr(f));
  
	  memcpy(&f,buf+8,4);
	  map->cam.z = f;
	  SetDlgItemText(IDC_ZCamCoordSt,FloatToStr(f));

	  memcpy(&f,buf+12,4);
	  map->cam.cView.w = f;
	  SetDlgItemText(IDC_QuatWSt,FloatToStr(f));

	  memcpy(&f,buf+16,4);
	  map->cam.cView.x = f;
	  SetDlgItemText(IDC_QuatXSt,FloatToStr(f));

	  memcpy(&f,buf+20,4);
	  map->cam.cView.y = f;
	  SetDlgItemText(IDC_QuatYSt,FloatToStr(f));

	  memcpy(&f,buf+24,4);
	  map->cam.cView.z = f;
	  SetDlgItemText(IDC_QuatZSt,FloatToStr(f));


	  //SetDlgItemText(IDC_HACamSt,FloatToStr(map->cam.HA));
	  //SetDlgItemText(IDC_VACamSt,FloatToStr(map->cam.VA));

	  MessageBox(" !");
//...    
	  delete [] buf;
	}
}

void Ccamedit::LoadFile()
{
    // 
	CString Path;
	GetDlgItemText(IDC_FILEPATH,Path);

	OPENFILENAME ofstruct;
	char *Filters;
	CString FileName;
	//bool DialogResult;

	// ...
	Filters = new char[17];
	Filters = "Cam-\0*.cam\0\0";
	//    ...
	FileName.GetBufferSetLength(256);
	// ...
	ZeroMemory(&ofstruct,sizeof (OPENFILENAME)); 

	ofstruct.lStructSize = sizeof (OPENFILENAME);
	ofstruct.hwndOwner = ProgaOpts->PAppObject->m_pMainWnd->m_hWnd;
	ofstruct.lpstrFilter = Filters;
	ofstruct.nFilterIndex = 1;  // 1- ;
	ofstruct.lpstrFile = FileName.GetBuffer(0);
	ofstruct.nMaxFile = 256;
	ofstruct.lpstrInitialDir = ProgaOpts->LastDir;
	ofstruct.lpstrTitle = "     ? ? ? ?(? _)";
	ofstruct.lpstrDefExt = "cam";
	ofstruct.Flags = OFN_FILEMUSTEXIST;
    //const char *tmpPth; 
    
	bool HaveOpenFname=false;
	bool PFE = PathFileExists(Path);

	if(!PFE)
	{
	   HaveOpenFname = GetOpenFileName(&ofstruct);
	}
	else
	{
	   HaveOpenFname = true;
	}

	if (HaveOpenFname)
	{

		FILE *f;
		int len;
	     
		if(!PFE)
		f = fopen((CString)ofstruct.lpstrFile,"r");
		else
		f = fopen(Path,"r");

		if(f)
		{
			//       
			if(!PFE)
			{
				WritePrivateProfileString("MainOptions","LastCamPath",(CString)ofstruct.lpstrFile,ProgaOpts->ProgDir+IniName);
				SetDlgItemText(IDC_FILEPATH,(CString)ofstruct.lpstrFile);
			}
			else
				WritePrivateProfileString("MainOptions","LastCamPath",Path,ProgaOpts->ProgDir+IniName);
			//  , WTFB! %)
			fseek(f,0,SEEK_END);
			len = ftell(f);  // 
			fseek(f,0,SEEK_SET);

			delete [] Buffer;
			Buffer = new byte[len];
			fread(Buffer,len,1,f);

			SetDlgItemText(IDC_ZAP_COUNT,IntToStr(len/36));
			SetDlgItemText(IDC_ZAP_NUM,"1");
			ShowView();
			fclose(f);
			FileOpened = true;
		}
		else
		{
			MessageBox("File %s not found!",Path);
		}
	}
}

void Ccamedit::SaveFile()
{
	FILE *f;
	CString Path,t;
	int len;
	GetDlgItemText(IDC_FILEPATH,Path);

	OPENFILENAME ofstruct;
	char *Filters;
	CString FileName;
	//bool DialogResult;
    
	// ...
	Filters = new char[17];
	Filters = "Cam-\0*.cam\0\0";
	//    ...
	FileName.GetBufferSetLength(256);
	// ...
	ZeroMemory(&ofstruct,sizeof (OPENFILENAME)); 

	ofstruct.lStructSize = sizeof (OPENFILENAME);
	ofstruct.hwndOwner = ProgaOpts->PAppObject->m_pMainWnd->m_hWnd;
	ofstruct.lpstrFilter = Filters;
	ofstruct.nFilterIndex = 1;  // 1- ;
	ofstruct.lpstrFile = FileName.GetBuffer(0);
	ofstruct.nMaxFile = 256;
	ofstruct.lpstrInitialDir = ProgaOpts->LastDir;
	ofstruct.lpstrTitle = "     ?     __ ?";
	ofstruct.lpstrDefExt = "cam";
	//ofstruct.Flags = OFN_FILEMUSTEXIST;

	bool PFE = PathFileExists(Path);

	if(!PFE)
	{
		GetSaveFileName(&ofstruct);
		Path = (CString)ofstruct.lpstrFile;
	}
	
	f = fopen(Path,"w");
	if(f)
	{
		SetDlgItemText(IDC_FILENAME,Path);
		WritePrivateProfileString("MainOptions","LastCamPath",Path,ProgaOpts->ProgDir+IniName);
		GetDlgItemText(IDC_ZAP_COUNT,t);
		len = StrToInt(t)*36;

		fseek(f,0,SEEK_SET);
		fwrite(Buffer,len,1,f);
		fclose(f);
		MessageBox(Path,"Saved successfull!");
	}
	else
	{
		MessageBox(Path,"Cunt save data into  file! :-)");
	}

}

void Ccamedit::ShowView()
{
	float f=0;
	int num = 0,max = 0;
	CString t ="";
	GetDlgItemText(IDC_ZAP_COUNT,t);
	max = StrToInt(t);
	GetDlgItemText(IDC_ZAP_NUM,t);
	num = StrToInt(t);
	if(num<=max)
	{
		//Time
		memcpy(&f,Buffer+(num-1)*36+0,4);
        t = FloatToStr(f);
		SetDlgItemText(IDC_ZAP_TIME,t);
		//Camera X
		memcpy(&f,Buffer+(num-1)*36+8,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_XCamCoordSt,t);
		map->cam.x = f;

		//Camera Y
		memcpy(&f,Buffer+(num-1)*36+12,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_YCamCoordSt,t);
		map->cam.y = f;

		//Camera Z
		memcpy(&f,Buffer+(num-1)*36+16,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_ZCamCoordSt,t);
		map->cam.z = f;

		//Quaterion W
		memcpy(&f,Buffer+(num-1)*36+20,4);
        t = FloatToStr(f);
		SetDlgItemText(IDC_QuatWSt,t);
		map->cam.cView.w = f;

		//Quaterion X
		memcpy(&f,Buffer+(num-1)*36+24,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_QuatXSt,t);
		map->cam.cView.x = f;

		//Quaterion Y
		memcpy(&f,Buffer+(num-1)*36+28,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_QuatYSt,t);
		map->cam.cView.y = f;

		//Quaterion Z
		memcpy(&f,Buffer+(num-1)*36+32,4);
		t = FloatToStr(f);
		SetDlgItemText(IDC_QuatZSt,t);
		map->cam.cView.z = f;

		vec3 angles = map->cam.cView.Quaternion_To_Euler();
		map->cam.HA = -angles.z;
		map->cam.YA = -angles.y;
        map->cam.VA = 180-angles.x;

		//   -    .
		SetDlgItemText(IDC_HACamSt,FloatToStr(map->cam.HA));
		SetDlgItemText(IDC_VACamSt,FloatToStr(map->cam.VA));
		SetDlgItemText(IDC_YACamSt,FloatToStr(map->cam.YA));
		SetDlgItemText(IDC_QuatXSt,FloatToStr(map->cam.GetCameraQuat().x));
		SetDlgItemText(IDC_QuatYSt,FloatToStr(map->cam.GetCameraQuat().y));
		SetDlgItemText(IDC_QuatZSt,FloatToStr(map->cam.GetCameraQuat().z));
		SetDlgItemText(IDC_QuatWSt,FloatToStr(map->cam.GetCameraQuat().w));
	}
	else
	{
		MessageBox("  !");
	}
}

void Ccamedit::SetView()
{
	int num = 0,max = 0;
	float time;
	CString t ="";
	GetDlgItemText(IDC_ZAP_COUNT,t);
	max = StrToInt(t);
	GetDlgItemText(IDC_ZAP_NUM,t);
	num = StrToInt(t);
	if(num<=max)
	{
		GetDlgItemText(IDC_ZAP_TIME,t);
        time = StrToInt(t)*1.0f;
        //Time
		memcpy(Buffer+(num-1)*36,&(time),4);

		//Camera X
		memcpy(Buffer+(num-1)*36+8,&(map->cam.x),4);

		//Camera Y
		memcpy(Buffer+(num-1)*36+12,&(map->cam.y),4);

		//Camera Z
		memcpy(Buffer+(num-1)*36+16,&(map->cam.z),4);

		//Quaterion W
		memcpy(Buffer+(num-1)*36+20,&(map->cam.GetCameraQuat().w),4);

	  	//Quaterion X
		memcpy(Buffer+(num-1)*36+24,&(map->cam.GetCameraQuat().x),4);

		//Quaterion Y
		memcpy(Buffer+(num-1)*36+28,&(map->cam.GetCameraQuat().y),4);

		//Quaterion Z
		memcpy(Buffer+(num-1)*36+32,&(map->cam.GetCameraQuat().z),4);
	}
	else
	{
		MessageBox("  !");
	}

}

void Ccamedit::PlayFile()
{
	if(FileOpened)
	{
	  //     
	  KillTimer(1);
	  SetDlgItemText(IDC_ZAP_NUM,"1");
	  if (!SetTimer(1, 1000, NULL))
  	    MessageBox("  !");
	  //MessageBox("  ,       ");
	}
}

void Ccamedit::ShowNextZap()
{
    int num = 0,max = 0;
	CString t ="";
	GetDlgItemText(IDC_ZAP_COUNT,t);
	max = StrToInt(t);
	GetDlgItemText(IDC_ZAP_NUM,t);
	num = StrToInt(t);
	if(num<max)
	{
	  SetDlgItemText(IDC_ZAP_NUM,IntToStr(num+1));
	  // 
      ShowView();
	  KillTimer(1);
	  UINT time;
	  time = 1000;
      SetTimer(1, time, NULL);
	}
	else
	{
	  KillTimer(1);
	}
}

void Ccamedit::Test()
{
	//MessageBox(" -  !");
	map->cam.HA = 0;
    map->cam.YA = 0;
	map->cam.VA = 0;
	SetDlgItemText(IDC_QuatWSt,"1");
	SetDlgItemText(IDC_QuatXSt,"0");
	SetDlgItemText(IDC_QuatYSt,"0");
	SetDlgItemText(IDC_QuatZSt,"0");
}

void Ccamedit::display()
{
/*
//////////////////////////////////////////////
	CPoint point;
	GLint	vp[4];
	glGetIntegerv(GL_VIEWPORT,vp);
	point.x = vp[2]/2;
	point.y = vp[3]/2;
	vec3 v = map->selectionRay( 0, point );
	//vec3 qsp = v;
	vec3 qsp = map->findSelect(v);
//////////////////////////////////////////////
	static GLUquadricObj	*q = gluNewQuadric();
	glPushMatrix();
		glTranslatef(qsp.x,qsp.y,qsp.z);
		gluSphere(q,1,110,110);
	glPopMatrix();
//	delete q;
*/
}


void Ccamedit::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	map->cam.z += 0.05f*zDelta;
	//   -    .
	SetDlgItemText(IDC_ZCamCoordSt,FloatToStr(map->cam.z));
}

void Ccamedit::onRButtonUp( UINT nFlags, CPoint point )
{
}

void Ccamedit::onLButtonUp ( UINT nFlags, CPoint point )
{
}

HICON Ccamedit::getIcon()
{
	return NULL;
}

Ccamedit::~Ccamedit()
{
	delete [] Buffer;
}

void Ccamedit::OnStnClickedQuatxst()
{
	
}

void Ccamedit::OnBnClickedInverse()
{
    map->cam.RotateH(180);
	//map->cam.RotateV(180);
	map->cam.RotateY(180);
}

void Ccamedit::OnTimer(UINT nIDEvent)
{
	if(nIDEvent==1)
	{
		ShowNextZap();
	}
	CPlugin::OnTimer(nIDEvent);
}

CWnd *Ccamedit::GetHandle()
{
	return handle;
}
void Ccamedit::OnBnClickedBtnExtended()
{
  //IDR_POPUP_MOVIES
}

int Ccamedit::GetRange(bool First,bool From)
{
	int rez = 0;
    CString t;
	if(First)
	{
	  if(From)
	  {
	    GetDlgItemText(IDC_FROM_1,t);
	  }
	  else
	  {
		GetDlgItemText(IDC_TO_1,t);
	  }
	}
	else
	{
	  if(From)
	  {
	    GetDlgItemText(IDC_FROM_1,t);
	  }
	  else
	  {
		GetDlgItemText(IDC_TO_1,t);
	  } GetDlgItemText(IDC_TO_2,t);
	}
	rez = StrToInt(t);
	return rez;
}

bool Ccamedit::IsInRange(int RangeMin, int RangeMax, int Num)
{
  bool b;
  if(IsRangeCorrect(RangeMin,RangeMax))
  {
	  b=(Num>=RangeMin)&&(Num<=RangeMax);
  }
  else
  {
	  b = false;
  }
  return b;
}

bool Ccamedit::IsRangeCorrect(int RangeMin, int RangeMax)
{
	bool b;
    b = (RangeMin<=RangeMax)&&(RangeMin>0);
	return b;
}

byte *Ccamedit::Delete(byte *buf, int len, int start, int count)
{
	byte *temp;
	temp = new byte[(len-count)*36];
	// ""
	if(start>1)
	  memcpy(temp,buf,(start-1)*36);
	// ""
    if(len>=start+count-1)
	  memcpy(temp+(start-1)*36,buf+(start+count-1)*36,(len-start-count+1)*36);
	return temp;
}


void Ccamedit::OnBnClickedBtnDel()
{
	if(FileOpened)
	{
	  CString t;
	  GetDlgItemText(IDC_ZAP_COUNT,t);
  
	  int From = GetRange(true,true);
	  int To=GetRange(true,false);
	  int ZapCount = StrToInt(t);
  
	  if(IsRangeCorrect(From,To))
	  {
		  byte *rez;
		  rez = Delete(Buffer,ZapCount,From,To - From + 1);
		  delete [] Buffer;
		  Buffer = rez;
		  t = IntToStr(ZapCount - To + From - 1);
		  SetDlgItemText(IDC_ZAP_COUNT,t);
		  MessageBox("0 !");
	  }
	  else
	  {
		  MessageBox("  !");
	  }
	}
	else
	{
		MessageBox("U mazd op'n ze fail b!4 ed!t !t ;)[    ,   !!!] -  ");
	}
}

void Ccamedit::OnBnClickedSaveCoords()
{
	Coordinates = vec3(map->cam.x,map->cam.y,map->cam.z);
	CString s;
	s.Format(": {X=%.5f; Y=%.5f; Z=%.5f}",map->cam.x,map->cam.y,map->cam.z);
	MessageBox(s);
}

void Ccamedit::OnBnClickedSaveView()
{
	Orientation = map->cam.GetCameraQuat();
	CString s;
    s.Format(": {HA=%.5f; YA=%.5f; VA=%.5f}",map->cam.HA,map->cam.YA,map->cam.VA);
	MessageBox(s);
}

byte *Ccamedit::Move(vec3 Start,quat ViewS, vec3 End, quat ViewE, float Time, int ZapNum, bool IsMove, bool IsRotate)
{
	// :      , 
	//        ,     
	//  6    "delta".

	byte *rez = new byte[ZapNum*36];
	if(rez)
	{
	  //  
	  if(ZapNum>0)
  	  {
	    //General
	    float dTime = Time/ZapNum;
	    float Unknown = 0;
	    //Move
	    float dX, dY, dZ;
	    ZapNum--;
	    dX = (IsMove)?(End.x - Start.x)/ZapNum:0;
	    dY = (IsMove)?(End.y - Start.y)/ZapNum:0;
	    dZ = (IsMove)?(End.z - Start.z)/ZapNum:0;

  	    //Rotate
	    float dQX, dQY, dQZ,AngleS,AngleE,dAngle;
	    AngleS = acos(2 * (ViewS.w * ViewS.w) - 1);
	    AngleE = acos(2 * (ViewE.w * ViewE.w) - 1);
	    dAngle = (IsRotate)?(AngleE - AngleS)/ZapNum:0;
	    dQX = (IsRotate)?(ViewE.x/sin(AngleE/2)-ViewS.x/sin(AngleS/2))/ZapNum:0;
	    dQY = (IsRotate)?(ViewE.y/sin(AngleE/2)-ViewS.y/sin(AngleS/2))/ZapNum:0;
	    dQZ = (IsRotate)?(ViewE.z/sin(AngleE/2)-ViewS.z/sin(AngleS/2))/ZapNum:0;
  
	    ZapNum++;
	  
	    vec3 TempVec;
	    quat TmpQuat;
	    for(int i=0;i<ZapNum;i++)
	    {
		    //   
		    TempVec = vec3(Start.x + dX*i,Start.y + dY*i,Start.z + dZ*i);
		    TmpQuat.w = cos((AngleS + dAngle*i)/2);
		    TmpQuat.x = (ViewS.x+dQX*i)/sin(AngleS/2)*sin((AngleS + dAngle*i)/2);
		    TmpQuat.y = (ViewS.y+dQY*i)/sin(AngleS/2)*sin((AngleS + dAngle*i)/2);
		    TmpQuat.z = (ViewS.z+dQZ*i)/sin(AngleS/2)*sin((AngleS + dAngle*i)/2);
		    // !

		    int size = 4;
			//byte *tmp = FillBlock(dTime,Unknown,TempVec.x,TempVec.y,TempVec.z,TmpQuat.w,TmpQuat.x,TmpQuat.y,TmpQuat.z);
			//memcpy(rez,tmp,36);
			//delete [] tmp;
		    
			memcpy(&rez[i*36     ],&dTime    ,size); //Time
		    memcpy(&rez[i*36 +  4],&Unknown  ,size); //Unk2
		    memcpy(&rez[i*36 +  8],&TempVec.x,size); //CamX
		    memcpy(&rez[i*36 + 12],&TempVec.y,size); //CamY
		    memcpy(&rez[i*36 + 16],&TempVec.z,size); //CamZ
		    memcpy(&rez[i*36 + 20],&TmpQuat.w,size); // QW
		    memcpy(&rez[i*36 + 24],&TmpQuat.x,size); // QX
		    memcpy(&rez[i*36 + 28],&TmpQuat.y,size); // QY
		    memcpy(&rez[i*36 + 32],&TmpQuat.z,size); // QZ
	    }
	  }
	  else
	  {
        MessageBox(" !      !");
	  }
	}
	else
	{
		MessageBox("  ! %(");
	}
	return rez;
}

byte *Ccamedit::FillBlock(float Time,float Unknown,float X,float Y,float Z,float qW,float qX,float qY,float qZ)
{
  byte *r = new byte[36];

  memcpy(&r[0] ,&Time   ,4);
  memcpy(&r[4] ,&Unknown,4);
  memcpy(&r[8] ,&X      ,4);
  memcpy(&r[12],&Y      ,4);
  memcpy(&r[16],&Z      ,4);
  memcpy(&r[20],&qW     ,4);
  memcpy(&r[24],&qX     ,4);
  memcpy(&r[28],&qY     ,4);
  memcpy(&r[32],&qZ     ,4);

  return r;
}

byte *Ccamedit::Cut(byte *buf, int len, int start, int count)
{
	byte *temp;
	temp = new byte[(count)*36];
	//
    if(len>count+start-1)
  	  memcpy(temp,buf+(start-1)*36,(count)*36);
	return temp;
}

byte *Ccamedit::Paste(byte *buf1, byte *buf2, int len1,int len2, int start)
{
	byte *temp;
	temp = new byte[(len1+len2)*36];
	// ""
	if(start>0)
      memcpy(temp,buf1,(start)*36);
	// ""
	  memcpy(temp+(start)*36,buf2,(len2)*36);
    // ""
	  memcpy(temp+(start+len2)*36,buf1+(start)*36,(len1-start)*36);
	return temp;
}
void Ccamedit::Swap(byte *buf, int len, int Start1, int Count1, int Start2, int Count2)
{
	byte *temp1, *temp2, *temp3, *temp4, *temp5;
	temp1 = Cut(buf,len,Start1,Count1);
	temp2 = Cut(buf,len,Start2,Count2);
	if(Start1>1)
	{
		temp3 = Cut(buf,len,1,Start1-1);
	}

	if(Start1+Count1<Start2)
	{
		temp4 = Cut(buf,len,Start1+Count1,Start2-Start1-Count1);
	}

	if(Start2+Count2-1<len)
	{
		temp5 = Cut(buf,len,Start2+Count2-1,len-Start2-Count2+1);
	}
	//Go!!!!!!!!
	if(Start1>1)
	{
		memcpy(buf,temp3,Start1-1);
		memcpy(buf+Start1-1,temp2,Count2);
		if(Start1+Count1<Start2)
		{
		  memcpy(buf+Start1-1+Count2,temp4,Start2-Start1-Count1);
		  delete [] temp4;
		}
	    memcpy(buf-1+Count2+Start2-Count1,temp1,Count1);
		if(Start2+Count2-1<len)
		{
		  memcpy(buf-1+Count2+Start2,temp5,len-Start2-Count2+1);
		  delete [] temp5;
		}
		delete [] temp1;
		delete [] temp2;
		delete [] temp3;
	}
	else
	{
		memcpy(buf+Start1-1,temp2,Count2);
		if(Start1+Count1<Start2)
		{
		  memcpy(buf+Start1-1+Count2,temp4,Start2-Start1-Count1);
		  delete [] temp4;
		}
	    memcpy(buf-1+Count2+Start2-Count1,temp1,Count1);
		if(Start2+Count2-1<len)
		{
		  memcpy(buf-1+Count2+Start2,temp5,len-Start2-Count2+1);
		  delete [] temp5;
		}
		delete [] temp1;
		delete [] temp2;
	}	
}

void Ccamedit::OnBnClickedBtnSwap()
{
  if(FileOpened)
  {
/*
    CString t;
	GetDlgItemText(IDC_ZAP_COUNT,t);
    int From = GetRange(true,true);
    int To=GetRange(true,false);
	int From2 = GetRange(false,true);
    int To2=GetRange(false,false);
    int ZapCount = StrToInt(t);
    Swap(Buffer,ZapCount,From,To-From+1,From2,To2-From2+1);
	MessageBox("  ...");
*/
	  MessageBox("  ,  ! :((( @");	
  }
}

void Ccamedit::OnBnClickedBtnInverce()
{
	
    CString t;
	GetDlgItemText(IDC_ZAP_COUNT,t);
    int From = GetRange(true,true);
    int To=GetRange(true,false);
    int ZapCount = StrToInt(t);  

	//byte *temp = Cut(Buffer,ZapCount,From,To-From+1);
	//Invert(temp,To-From+1);
	//memcpy(Buffer+(From-1)*36,temp,(To-From+1)*36);
	Invert(Buffer,ZapCount);
	//delete [] temp;
	
	//MessageBox("    !");
}

void Ccamedit::Invert(byte *buf, int len)
{
	byte *temp = new byte[len*36];
	for(int i=0;i<len;i++)
	{
		float t1, t2;
		//
		memcpy(temp+i*36,buf+(len-i-1)*36,36);
		//Time
        if(i!=len-i-1)
		{
            //Get time
			memcpy(&t1,buf+(len-i-1)*36,4);
			memcpy(&t2,temp+i*36,4);
            //Set time
			memcpy(buf+(len-i-1)*36,&t2,4);
			memcpy(temp+i*36,&t1,4);
		}
	}
	//      ! :-)
	memcpy(buf,temp,len*36);
	delete [] temp;
}

void Ccamedit::OnBnClickedBtnMove()
{
	MessageBox("  ");
}

void Ccamedit::OnBnClickedBtnRotate()
{
    MessageBox("  ");
}

void Ccamedit::OnBnClickedBtnPointLook()
{
	MessageBox("");
}

void Ccamedit::OnBnClickedBtnTrack()
{
	MessageBox(" ...       ... :-(");
}

void Ccamedit::OnBnClickedBtnTime()
{
	MessageBox("  ");
}

void Ccamedit::Apply()
{
	CString t;
	int X,Y,Z, hA,vA,yA;
	//X, Y, Z
	GetDlgItemText(IDC_XCamCoordSt,t);
	X = StrToInt(t);
    GetDlgItemText(IDC_YCamCoordSt,t);
	Y = StrToInt(t);
	GetDlgItemText(IDC_ZCamCoordSt,t);
	Z = StrToInt(t);
	//HA, VA, YA
	GetDlgItemText(IDC_HACamSt,t);
	hA = StrToInt(t);
    GetDlgItemText(IDC_YACamSt,t);
	yA = StrToInt(t);
	if(IsDlgButtonChecked(IDC_INVERT_YA))yA+=180;
	GetDlgItemText(IDC_VACamSt,t);
	vA = StrToInt(t);
	//Apply:
	map->cam.x = X;
	map->cam.y = Y;
	map->cam.z = Z;
	map->cam.HA = hA;
	map->cam.YA = yA;
	map->cam.VA = vA;
	//Show quat:
	quat Q = map->cam.GetCameraQuat();
	t = FloatToStr(Q.w);
	SetDlgItemText(IDC_QuatWSt,t);
	t = FloatToStr(Q.x);
	SetDlgItemText(IDC_QuatXSt,t);
	t = FloatToStr(Q.y);
	SetDlgItemText(IDC_QuatYSt,t);
	t = FloatToStr(Q.z);
	SetDlgItemText(IDC_QuatZSt,t);
}

void Ccamedit::ShowPrev()
{
  if(FileOpened)
  {
    CString t;
    int n;
    GetDlgItemText(IDC_ZAP_NUM,t);
    n = StrToInt(t);
    if(n>1)
	{
		n--;
		t = IntToStr(n);
		SetDlgItemText(IDC_ZAP_NUM,t);
		ShowView();
	}
  }
}

void Ccamedit::ShowNext()
{
  if(FileOpened)
  {
    CString t;
    int n,z;
    GetDlgItemText(IDC_ZAP_NUM,t);
    n = StrToInt(t);
    GetDlgItemText(IDC_ZAP_COUNT,t);
	z = StrToInt(t);
    if(n<z)
	{
		n++;
		t = IntToStr(n);
		SetDlgItemText(IDC_ZAP_NUM,t);
		ShowView();
	}
  }
}

void Ccamedit::NewZap()
{
	CString t;
	GetDlgItemText(IDC_ZAP_COUNT,t);
	byte *temp = new byte[StrToInt(t)*36];
	memcpy(temp,Buffer,StrToInt(t)*36);
	delete [] Buffer;
	Buffer = new byte[(StrToInt(t)+1)*36];
	memcpy(Buffer,temp,StrToInt(t)*36);
	memcpy(Buffer+StrToInt(t)*36,temp,36);
	delete [] temp;
	SetDlgItemText(IDC_ZAP_COUNT,IntToStr(StrToInt(t)+1));
    SetDlgItemText(IDC_ZAP_NUM,IntToStr(StrToInt(t)+1));
	SetView();
}

void Ccamedit::RemoveZap()
{
	CString n;
	GetDlgItemText(IDC_ZAP_NUM,n);
	SetDlgItemText(IDC_FROM_1,n);
	SetDlgItemText(IDC_TO_1,n);
	OnBnClickedBtnDel();
}

void Ccamedit::Offset(byte *buf,int len, int from, int to, float X,float Y,float Z)
{
	float dx, dy, dz;
	//
	if((from>=1)&&(to>=from)&&(to<=len))
	for(int i=from-1;i<to;i++)
	{
		//X
		memcpy(&dx,buf+i*36+8,4);
		dx+=X;
		memcpy(buf+i*36+8,&dx,4);
		//Y
		memcpy(&dy,buf+i*36+12,4);
		dy+=Y;
		memcpy(buf+i*36+12,&dy,4);
		//Z
		memcpy(&dz,buf+i*36+16,4);
		dz+=Z;
		memcpy(buf+i*36+16,&dz,4);
	}
}
void Ccamedit::BtnOffset()
{
  int from = GetRange(true,true),to = GetRange(true,false);
  CString t;
  GetDlgItemText(IDC_ZAP_COUNT,t);
  int Zap=StrToInt(t);
  int dx,dy,dz;
  GetDlgItemText(IDC_XCamCoordSt,t);
  dx = StrToInt(t);
  GetDlgItemText(IDC_YCamCoordSt,t);
  dy = StrToInt(t);
  GetDlgItemText(IDC_ZCamCoordSt,t);
  dz = StrToInt(t);
  //Offset(Buffer,Zap,from,to,Coordinates.x,Coordinates.y,Coordinates.z);
  Offset(Buffer,Zap,from,to,dx,dy,dz);
  ShowView();
}
