#include "stdafx.h"
#include "resource.h"
#include "Chillmaker.h"
#include <EIplugin\cplugin_base.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "resource.h"
CHillPlugin	plugin;

CHillPlugin::CHillPlugin()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CHillPlugin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CHillPlugin::~CHillPlugin()

{
	//{{AFX_DATA_INIT(CHillPlugin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CHillPlugin::DoDataExchange(CDataExchange* pDX)
{
	CPlugin::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHillPlugin)
	DDX_Control(pDX, IDC_EDIT2, m_edit2);
	DDX_Control(pDX, IDC_SPIN2, m_spin2);
	DDX_Control(pDX, IDC_EDIT1, m_edit1);
	DDX_Control(pDX, IDC_SPIN1, m_spin1);
	//}}AFX_DATA_MAP
}

void CHillPlugin::Create( CWnd* pParentWnd )
{
	CDialog::Create( CHillPlugin::IDD, pParentWnd );

	tip = "Hills creator";
	map = NULL;
	icon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

BEGIN_MESSAGE_MAP(CHillPlugin, CDialog)
	//{{AFX_MSG_MAP(CHillPlugin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CHillPlugin::onMouseMove (UINT nFlags, CPoint point)
{
	vec3 vs,ptr;
	vs =  map->selectionRay( nFlags, point );
	ptr = map->findSelect( vs );
	x = (unsigned int)ptr.x;
	y = (unsigned int)ptr.y;
	z = (unsigned int)ptr.z;
};
void CHillPlugin::onRButtonDown  ( UINT nFlags, CPoint point )
{
};
void CHillPlugin::onLButtonDown  ( UINT nFlags, CPoint point )
{
	int i,j,r;
	float z_;
	r = m_spin1.GetPos();
	for( i = x-r;i< x+r;i++ )
	for( j = y-r;j< y+r;j++ )
	{
		if( i >= 0 && i < (int)map->getMapXDimension()-1 && j < (int)map->getMapYDimension()-1 )
		{
			float tmp = (float)(r*r - (i-x)*(i-x) - (j-y)*(j-y));
			z_ = (tmp>0)?sqrt(tmp):0;
			map->setHMapZ( i,j,map->getHMapZ( i,j )+(unsigned int)(z_/map->getvZoom()*65536.0f));
		}
	}
	map->refresh();

};
void CHillPlugin::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void CHillPlugin::onRButtonDblClk( UINT nFlags, CPoint point )
{
};

CPlugin*	getPlugin( )
{
	return (CPlugin*)(&plugin);
}

void CHillPlugin::onPluginSelect()
{
}

void CHillPlugin::onPluginUnSelect()
{
}

void CHillPlugin::hillPoint( int rad,int scale,int i,int j )
{
	float z_,tmp;
	tmp = (float)(rad*rad - (i-x)*(i-x) - (j-y)*(j-y));
	z_ = (tmp>0)?sqrt(tmp):0;
	glVertex3f( i  ,j  ,map->scaleZ(map->getHMapZ( i  ,j   ) + (unsigned int)(z_/map->getvZoom()*65536.0f*(float)scale/100.0f)) );
}

void CHillPlugin::display()
{
	int r,i,j,s;
	r = m_spin1.GetPos();
	s = m_spin2.GetPos();
	glColor3d(1,0,0);
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
	glPolygonMode( GL_FRONT, GL_LINE );
	if( x-r >= 0 && y-r >= 0 && x+r < (int)map->getMapXDimension()-1 && y+r < (int)map->getMapYDimension()-1  )
	for( i = x-r;i< x+r-1;i++ )
	for( j = y-r;j< y+r-1;j++ )
	{
		glBegin(GL_QUADS);
			hillPoint( r , s , i  , j   );
			hillPoint( r , s , i+1, j   );
			hillPoint( r , s , i+1, j+1 );
			hillPoint( r , s , i  , j+1 );
		glEnd();
	}
	glPolygonMode( GL_FRONT, GL_FILL );
	glEnable( GL_TEXTURE_2D );
	glColor3d(1,1,1);
	glEnable( GL_DEPTH_TEST );
}

void CHillPlugin::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	map->cam.z += 0.05f*zDelta;
}

BOOL CHillPlugin::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_spin1.SetBuddy(&m_edit1);
	m_spin1.SetRange(0,100);
	m_spin1.SetPos(5);
	m_spin2.SetBuddy(&m_edit2);
	m_spin2.SetRange(0,200);
	m_spin2.SetPos(100);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHillPlugin::onRButtonUp (UINT nFlags, CPoint point)
{
}

void CHillPlugin::onLButtonUp (UINT nFlags, CPoint point)
{
}

HICON CHillPlugin::getIcon()
{
	return NULL;
}

