#include "stdafx.h"
#include "resource.h"
#include "CMView.h"
#include <EIplugin\cplugin_base.h>

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif
#include "resource.h"
CMouseMover	plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog


CMouseMover::CMouseMover()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CPlugin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMouseMover::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlugin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

void CMouseMover::Create( CWnd* pParentWnd )
{
	CDialog::Create( CMouseMover::IDD, pParentWnd );
	icon = AfxGetApp()->LoadIcon( IDI_ICON1 );
	tip = "Move";
	oldLPos.x = 0;
	oldLPos.y = 0;
	oldLPos.z = 0;
	oldLPos.x = 0;
	oldLPos.y = 0;
	oldLPos.z = 0;
}

BEGIN_MESSAGE_MAP(CMouseMover, CDialog)
	//{{AFX_MSG_MAP(CPlugin)
	ON_BN_CLICKED(IDC_BTN_INFO, GetMapInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CMouseMover::onMouseMove    ( UINT nFlags, CPoint point )
{
	if( nFlags & MK_LBUTTON )
	{
			vec3 t1,t2,v;
			float temp;
	
			v = map->selectionRay( nFlags, point );
	
			temp = -map->cam.z/v.z;

			t2.x = map->cam.x + temp*v.x;
			t2.y = map->cam.y + temp*v.y;
			t2.z = map->cam.z + temp*v.z;

			v.x = oldLPos.x - map->cam.x;
			v.y = oldLPos.y - map->cam.y;
			v.z = oldLPos.z - map->cam.z;

			temp = -map->cam.z/v.z;
			t1.x = map->cam.x + temp*v.x;
			t1.y = map->cam.y + temp*v.y;
			t1.z = map->cam.z + temp*v.z;
			map->cam.x += (float)( oldLPos.x - t2.x );
			map->cam.y += (float)( oldLPos.y - t2.y );
	}
	if( nFlags & MK_RBUTTON )
	{
		CPoint offset  = point - start;
		HA = (float)offset.x/5.0f;
		VA = (float)offset.y/5.0f;
		if( !GetAsyncKeyState( VK_SHIFT ) )
		map->cam.RotateH( HA );
		if( !GetAsyncKeyState( VK_CONTROL ) )
		map->cam.RotateV( VA );
/////////////////////////////////////////////////////////
	glPushMatrix();
		glLoadIdentity();
		mat4 mrx,mrz,mt,mv;
		mrx.rotation_x( map->cam.VA );
		mrz.rotation_z( map->cam.HA );
		mt.translate( -map->cam.x,-map->cam.y,-map->cam.z );
		mv = mrx*mrz*mt;
		glMultMatrixf(&mv[0]);

		CPoint	qpoint;
		GLint	vp[4];
		glGetIntegerv(GL_VIEWPORT,vp);
		qpoint.x = vp[2]/2;
		qpoint.y = vp[3]/2;
		vec3 v = map->selectionRay( nFlags, qpoint );
		v.normalize();
	glPopMatrix();
	vec3 ep1;
	ep1.x = map->cam.x + v.x*len;
	ep1.y = map->cam.y + v.y*len;
	ep1.z = map->cam.z + v.z*len;
	vec3 offs = ep1 - sp;

/////////////////////////////////////////////////////////
		start = point;
		map->cam.x -= offs.x;
		map->cam.y -= offs.y;
		map->cam.z -= offs.z;
	}
};
void CMouseMover::onRButtonDown  ( UINT nFlags, CPoint point )
{
	GLint	vp[4];
	glGetIntegerv(GL_VIEWPORT,vp);
	start = point;
	point.x = vp[2]/2;
	point.y = vp[3]/2;
	vec3 v = map->selectionRay( nFlags, point );
	sp = map->findSelect( v );
	view = sp - vec3( map->cam.x,map->cam.y,map->cam.z );
	len = (vec3( map->cam.x,map->cam.y,map->cam.z ) - sp).length();
};
void CMouseMover::onLButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 v;
	float t;

	v = map->selectionRay( nFlags, point );
	t =	-map->cam.z/v.z;
	oldLPos.x = map->cam.x + t*v.x;
	oldLPos.y = map->cam.y + t*v.y;
	oldLPos.z = map->cam.z + t*v.z;


};
void CMouseMover::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void CMouseMover::onRButtonDblClk( UINT nFlags, CPoint point )
{
};

/////////////////////////////////////////////////////////////////////////////
// CPlugin message handlers
CPlugin*	getPlugin( )
{
	return (CMouseMover*)(&plugin);
}

void CMouseMover::onPluginSelect()
{
}

void CMouseMover::onPluginUnSelect()
{
}

void CMouseMover::display()
{
/*
//////////////////////////////////////////////
	CPoint point;
	GLint	vp[4];
	glGetIntegerv(GL_VIEWPORT,vp);
	point.x = vp[2]/2;
	point.y = vp[3]/2;
	vec3 v = map->selectionRay( 0, point );
	vec3 qsp = map->findSelect( map->cam, v );
//////////////////////////////////////////////
	static GLUquadricObj	*q = gluNewQuadric();
	glPushMatrix();
		glTranslatef(qsp.x,qsp.y,qsp.z);
		gluSphere(q,1,110,110);
	glPopMatrix();
//	delete q;
*/
}

void CMouseMover::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	map->cam.z += 0.05f*zDelta;
}

void CMouseMover::onRButtonUp( UINT nFlags, CPoint point )
{
}

void CMouseMover::onLButtonUp ( UINT nFlags, CPoint point )
{
}

HICON CMouseMover::getIcon()
{
	return NULL;
}

CMouseMover::~CMouseMover()
{
}


void CMouseMover::GetMapInfo()
{
	CString Rez;
	GLuint x = (map->getMapXDimension()-1)/32, y = (map->getMapYDimension()-1)/32;
	Rez.Format(" : %ix%i ",x,y);
	
	SetDlgItemText(IDC_FOR_INFO, Rez);
	DoDataExchange(TO);
}