
#if !defined(AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_)
#define AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// CPlugin.h : header file
//
//#include "gameTypes.h"
//#include <mprbase.h>
#include <EIPlugin\CPlugin_base.h>
#include "CTexPreset.h"
#include "afxwin.h"
#define PLUGIN_API 	extern "C" _declspec(dllexport)
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog

class CTex : public CPlugin
{
// Construction
public:
	CTex( );   // standard constructor
	virtual void Create( CWnd* );

	virtual void onMouseMove    ( UINT nFlags, CPoint point );
	virtual void onRButtonDown  ( UINT nFlags, CPoint point );
	virtual void onLButtonDown  ( UINT nFlags, CPoint point );
	virtual void onRButtonUp  ( UINT nFlags, CPoint point );
	virtual void onLButtonUp  ( UINT nFlags, CPoint point );
	virtual void onLButtonDblClk( UINT nFlags, CPoint point );
	virtual void onRButtonDblClk( UINT nFlags, CPoint point );
	virtual void onMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	virtual	void onPluginSelect();
	virtual	void onPluginUnSelect();
	virtual void display();

	//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	virtual void FillMatList();
	void RefreshInfo(int x,int y);

	void TextureExtended(unsigned int x, unsigned int y, byte N, bool IsNeedExtended = true);
	void RandomizeRect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2);
	void RandomRotRect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2);
	byte CurrentMaterial;
	int GR;
	bool Firstloaded;
	//---------------------------------------------------------
	HICON getIcon();
public:
	CMaterialDlg	m;
	CTexPreset tOpt;
private:
// Dialog Data
	//{{AFX_DATA(CTex)
	enum { IDD = IDD_PLUGIN };
	CButton	m_brush;
	//}}AFX_DATA
	rgb*	img;
	unsigned int	x,y,z;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTex)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	CBitmap		hbmScreen;
    CDC         dcMem, *hdcScreen;
	CPoint	startPos,endPos;
	// Generated message map functions
	//{{AFX_MSG(CTex)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg void OnSingleTitle();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedLoadCfg();
	afx_msg void OnBnClickedTestbutton();
	CListBox MList;
	afx_msg void OnLbnSelchangeMatList();
	afx_msg void OnBnClickedExtended();
	afx_msg void OnBnClickedRndMap();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStnClickedSingleTitle();
};



PLUGIN_API	CPlugin*	getPlugin( );
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_)
