#if !defined(AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_)
#define AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CPlugin.h : header file
//
#include <EIPlugin\CPlugin_base.h>
#include "WaterQuadro.h"

#define PLUGIN_API 	extern "C" _declspec(dllexport)
typedef std::set<CWaterQuadro> SET;
typedef std::vector<SET::iterator> VEC;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog

class CWaterEdit : public CPlugin
{
// Construction
public:
	CWaterEdit( );   // standard constructor
	virtual void Create( CWnd* );

	virtual void onMouseMove    ( UINT nFlags, CPoint point );
	virtual void onRButtonDown  ( UINT nFlags, CPoint point );
	virtual void onLButtonDown  ( UINT nFlags, CPoint point );
	virtual void onLButtonUp  ( UINT nFlags, CPoint point );
	virtual void onRButtonUp  ( UINT nFlags, CPoint point );
	virtual void onLButtonDblClk( UINT nFlags, CPoint point );
	virtual void onRButtonDblClk( UINT nFlags, CPoint point );
	virtual void onMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	virtual	void onPluginSelect();
	virtual	void onPluginUnSelect();
	virtual void display();
	virtual HICON getIcon();
private:
	void AddTitleToSelection( int,int );
	vec3	sp,ep;
	SET	sWCells;
	rgb color;
private:
	bool ScanLine( int,int );
	bool InvertST( int,int );

	void Union();
	void Intersection();
	void Substraction();
// Dialog Data
	//{{AFX_DATA(CWaterSelect)
	enum { IDD = IDD_PLUGIN };
	CListBox	m_OperationsList;
	CFrameWnd*	pParentWnd;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWaterSelect)
	public:

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	int	x,y;
// Implementation
protected:
	
	// Generated message map functions
	//{{AFX_MSG(CWaterSelect)
	virtual BOOL OnInitDialog();
	afx_msg void OnRadio3();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

PLUGIN_API	CPlugin*	getPlugin( );
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CPLUGIN_H__637A9258_B163_4ADB_9AB5_AE06713B515C__INCLUDED_)
