// eimpredDoc.h : interface of the CEimpredDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EIMPREDDOC_H__14407829_2872_4219_854E_164F671392E0__INCLUDED_)
#define AFX_EIMPREDDOC_H__14407829_2872_4219_854E_164F671392E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "MainFrm.h"
#include "LoadInfo.h"

class CEimpredDoc : public CDocument
{
protected: // create from serialization only
	CEimpredDoc();
	DECLARE_DYNCREATE(CEimpredDoc)

// Attributes
public:
//	Camera Frustum;
	CString	shortFileName;
	bool			maploaded;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEimpredDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void ClearMprDirectory();
	void Idle();
	virtual void OnCloseDocument( );
	virtual BOOL OnOpenDocument( LPCTSTR lpszPathName );
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual ~CEimpredDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEimpredDoc)
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EIMPREDDOC_H__14407829_2872_4219_854E_164F671392E0__INCLUDED_)
