// LoadInfo.cpp : implementation file
//

#include "stdafx.h"
#include "eimpred.h"
#include "LoadInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LoadInfo	*lInf;
/////////////////////////////////////////////////////////////////////////////
// LoadInfo dialog


LoadInfo::LoadInfo(CWnd* pParent /*=NULL*/)
	: CDialog(LoadInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(LoadInfo)
	//}}AFX_DATA_INIT
}


void LoadInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LoadInfo)
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_PROGRESS2, m_Textures);
	DDX_Control(pDX, IDC_PROGRESS1, m_Sectors);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(LoadInfo, CDialog)
	//{{AFX_MSG_MAP(LoadInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LoadInfo message handlers

BOOL LoadInfo::Create( CWnd* pParentWnd ) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::Create(IDD, pParentWnd);
}

BOOL LoadInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	m_Sectors.SetRange(0,100);
	m_Textures.SetRange(0,100);
	m_Sectors.SetPos(0);
	m_Textures.SetPos(0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void	CALLBACK	progress( ProgressTypes	type,void*	data )
{
	CString s;
	int l,u;
	switch	(type)
	{
		case PT_SET_TITLE_COUNT:
			 lInf->m_Textures.SetRange(0,*(short*)(data)*64);
			 s.Format(" :%d",*(short*)(data)*64);
			 lInf->m_Status.SetWindowText(s);
		break;
		case PT_LOAD_TITLE:
			 lInf->m_Textures.OffsetPos(1);
			 lInf->m_Textures.GetRange(l,u);
			 s.Format(" :%d  %d",lInf->m_Textures.GetPos(),u);
			 lInf->m_Status.SetWindowText(s);
		break;
		case PT_MESSAGE:
			 lInf->m_Status.SetWindowText( (char*)data );
		break;
		case PT_SET_SECTION_COUNT:
			 lInf->m_Sectors.SetRange(0,*(short*)(data));
			 s.Format(" :%d",*(short*)(data));
			 lInf->m_Status.SetWindowText(s);
		break;
		case PT_LOAD_SECTION:
			 lInf->m_Sectors.OffsetPos(1);
			 lInf->m_Sectors.GetRange(l,u);
			 s.Format(" :%d  %d",lInf->m_Sectors.GetPos(),u);
			 lInf->m_Status.SetWindowText(s);
		break;
	}
	lInf->RedrawWindow();
}
