// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__98EDAE6D_3E53_453E_84E8_0D756A643415__INCLUDED_)
#define AFX_MAINFRM_H__98EDAE6D_3E53_453E_84E8_0D756A643415__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "mybar.h"
#include "PluginManager.h"
#include "LightModel.h"
#include "PluginsBar.h"

class CMainFrame : public CFrameWnd
{
	friend	class CEimpredApp;
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CMyBar		m_wndMyBar;
	CPluginsBar m_pbar;

	CLightModel	lightscavegipat,
				lightscaveingos,
				lightscavesuslanger,
				lightsgipat,
				lightsingos,
				lightssuslanger;
// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	afx_msg void OnPluginChange1( UINT nID );
	afx_msg void OnPluginChange2( UINT nID );
	afx_msg void OnPluginChange3( UINT nID );
	afx_msg void OnViewMinimap();
	afx_msg void OnViewWireframe();
	afx_msg void OnViewNormals();
	afx_msg void OnSetShowlight();
	afx_msg void OnViewPluginsdialogbar();
	afx_msg void OnSettings1();
	afx_msg void OnViewPcpanel();
	afx_msg void OnViewPgpanel();
	afx_msg void OnViewPtpanel();
	afx_msg void OnViewMapobjectsLandscape();
	afx_msg void OnViewMapobjectsWater();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__98EDAE6D_3E53_453E_84E8_0D756A643415__INCLUDED_)
