//////////////////////////////////////////////////////////
//                                                      //
//                                                      //
//                          //
//                               //
//                    .                       //
//                                                      //
//                                                      //
//////////////////////////////////////////////////////////



#if !defined(OptionsManagerIncluded)
#define OptionsManagerIncluded

#include "eimpred.h"

const CString IniName = "eimpred.ini";
const CString IniVer = "2";

class COptManager
{
public:
	//  
	CString LastDir;                  //  
	CString GameDir;                  //  

	// 
	CEimpredApp *PAppObject;          //   ...
	CString ProgDir;                  //  
	CString MapFileName;              // mpr-
	CString RealMapName;              //   ( -  )

	//
	COptManager(CEimpredApp *PAppObj);           //
	virtual ~COptManager();  //.
	bool LoadOptsFromIni();  //   ...
	bool SaveOptsToIni();    //.    .
	void MatchIniVersion();  // ini-   .
private:
	bool GetEIFolder( char* path );       //    ...
};

#endif