// eimpred.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "eimpred.h"

#include "MainFrm.h"
#include "eimpredDoc.h"
#include "eimpredView.h"
#include "Shlobj.h"
#include "objbase.h"
#include "afxwin.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool GetEIFolder( char* path );
/////////////////////////////////////////////////////////////////////////////
// CEimpredApp

BEGIN_MESSAGE_MAP(CEimpredApp, CWinApp)
	//{{AFX_MSG_MAP(CEimpredApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	//ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	//ON_COMMAND(ID_FILE_SAVE, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CEimpredApp::CEimpredApp()
{
	AfxEnableMemoryTracking( FALSE );
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CEimpredApp::~CEimpredApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CEimpredApp		theApp;
CEimpredView	*View;
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BOOL CEimpredApp::InitInstance()
{
	//Log->AddLog( " ", CLogFile::modeOk );
//	AfxEnableMemoryTracking(FALSE);
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	bool openregistry = true;
	// MFC- -
	SetRegistryKey(_T("Evil Islands Landscape Editor"));
	//    .
	//      *.ini - .
	ProgaOpts = new COptManager(this);
	//DWORD	count = 0;
	char *_path;
	_path = new char[256];
	ZeroMemory(_path,256);
		//ProgaOpts->GameDir = GetProfileString( "Settings", "WORK PATH" );
		//if( ProgaOpts->GameDir.GetLength( ) == 0 )
		//{
			
			//if( GetEIFolder( _path ) ) 
			//{
			//	ProgaOpts->GameDir.Format( "%s\\",_path);
		//		WriteProfileString( "Settings", "WORK PATH", ProgaOpts->GameDir );
			//}
			//else exit(-1);
	//	}
	Log->AddLog( "  :", CLogFile::modeOk );
	Log->AddLog( ProgaOpts->GameDir, CLogFile::modeOk );
	//ZeroMemory( _path, 256 );
	//strncpy( _path,m_pszHelpFilePath,strlen(m_pszHelpFilePath) - 11 );
	//SelfDir = _path;
	Log->AddLog( " :", CLogFile::modeOk );
	Log->AddLog( ProgaOpts->ProgDir, CLogFile::modeOk );
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	Log->AddLog( " SDI- ", CLogFile::modeOk );
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CEimpredDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEimpredView));
	AddDocTemplate(pDocTemplate);
	Log->AddLog( "  .", CLogFile::modeOk );

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;

	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_MAXIMIZE);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();
	View = ((CEimpredView*)((CMainFrame*)m_pMainWnd)->GetActiveView());

	View->light = &((CMainFrame*)m_pMainWnd)->lightsgipat;
	CString s("application started\n");
//	Log->AddLog( s.GetBuffer( s.GetLength() ), CLogFile::modeOk );
	return TRUE;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

int CALLBACK BFFCallBack(  HWND hWnd,  UINT uMsg,  LPARAM lParam,  LPARAM lpData)
{
	TCHAR szPath[_MAX_PATH];
    switch (uMsg) {
    case BFFM_INITIALIZED:
        if (lpData)
            SendMessage(hWnd,BFFM_ENABLEOK ,0,lpData);
        break;
    case BFFM_SELCHANGED:
			SHGetPathFromIDList(LPITEMIDLIST(lParam),szPath);
			CString s;
			s.Format( "%s\\starter.exe",szPath);
			FILE *f = fopen(s,"rb");
			if(f)
			{
				fclose(f);
			}
			else
				SendMessage(hWnd,BFFM_ENABLEOK ,0,lpData);
        break;
    }

	return 1;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
bool GetEIFolder( char* path )
{
    bool result = false;
	CoInitialize(  NULL	);    
    LPMALLOC pMalloc;
    if (::SHGetMalloc(&pMalloc) == NOERROR) {
        BROWSEINFO bi;
        ::ZeroMemory(&bi,sizeof bi);
		bi.lpszTitle = "    ";
		bi.lpfn = BFFCallBack;
		bi.ulFlags =  BIF_RETURNONLYFSDIRS;
        LPITEMIDLIST pidl = ::SHBrowseForFolder(&bi);
        if (pidl != NULL) {
            if (::SHGetPathFromIDList(pidl,path))
                result = true;
            pMalloc->Free(pidl);
        }
        pMalloc->Release();
    }
	return result;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnMakeMinimap();
	afx_msg void OnShowRect();
	afx_msg void OnStnClickedEaster();
	CEdit Pass;
	afx_msg void OnBnClickedHint();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_PASSWORD, Pass);
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_MAKE_MINIMAP, CAboutDlg::OnMakeMinimap)
	ON_COMMAND(ID_SHOW_RECT, CAboutDlg::OnShowRect)
	ON_BN_CLICKED(IDC_HINT, OnBnClickedHint)
END_MESSAGE_MAP()
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BOOL CEimpredApp::OnIdle(LONG lCount) 
{
	// TODO: Add your specialized code here and/or call the base class
		View->display();
		View->SwapBuffers();
	CWinApp::OnIdle(lCount);
	return TRUE;
}

void CAboutDlg::OnMakeMinimap()
{
  map->cam.HA = 0;
  map->cam.VA = 0;
  map->cam.x = map->getMapXDimension()/2;
  map->cam.y = map->getMapYDimension()/2;
  map->cam.z = 30;
}

void CAboutDlg::OnShowRect()
{
  MessageBox("  ...     %)","!");
}


void CAboutDlg::OnBnClickedHint()
{
	MessageBox(".\r\n    GipatGroup.\r\n $10,    !");
	SetDlgItemText(IDC_PASSWORD,"");
	Pass.EnableWindow(false);
	GetDlgItem(IDC_HINT)->EnableWindow(false);
}
