#include "CPresetEditor.h"

void CPE::LoadBuf(const CString Path)
{
	FILE *file;

	file = fopen(Path,"r");
    if(file)
	{	 
      if(BufLen>0)delete [] buf;

	  fseek(file,0,SEEK_END);
	  BufLen = ftell(file);
	  if(BufLen>4)
	  {
        buf = new byte[BufLen];
	    fseek(file,0,SEEK_SET);
	    fread(buf,BufLen,1,file);
	  }
	  else
	  {
        BufLen = 0;
	  }
      fclose(file);
	  //Init...
      
	  byte h1 = 28, h2 = 225, h3 = 0, h4 = 0;
	  
	  memcpy(&h3,buf,1);
      memcpy(&h4,buf+2,1);
	  if((h3!=h1 || h4!=h2) && (BufLen>0))
	  {
        BufLen = 0;
		delete [] buf;
	  }
	  if(BufLen>=5)
	  {
	    memcpy(&MatCount,buf+4,1);
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLen>k+9)
		{
			memcpy(&ZapCount,buf+9+k,2);
		}
	  }
	}
}
void CPE::SaveBuf(const CString Path)
{
	FILE *file;

	file = fopen(Path,"w");
    if(file)
	{	 
	  fseek(file,0,SEEK_SET);
	  fwrite(buf,BufLen,1,file);
      fclose(file);
	}
}
CString CPE::GetCaption(const byte Num)
{
  if(BufLen<4)
	  return "Error#1 Void array";
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  CString Rez="";
  char *tmp;
  bool ti = false;
  if(GetMatCount()>Num)
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        //Rez.SetLength( (int)(L+1) );
		if(ti)delete [] tmp;
        tmp = new char[L+1];
		ti = true;
		memcpy(tmp,buf+Cursor,L);
		Cursor+=L;
		memcpy(tmp+L,&Zero,1);
	  }
  Rez = CString(tmp,L+1);
  delete [] tmp;
  return Rez;
}
int CPE::GetCode(const byte Num)
{
  if(BufLen<4)
	  return 0;
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  if(GetMatCount()>Num)
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        Cursor+=L;
	  }
  return N;
}
CTitle CPE::GetZap(const int Num)
{
    CTitle Rez=CTitle();
	if(Num<GetZapCount())
	{
	  if(BufLen>=5)
	  {
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLen>k+9)
		{
			k+=9+2;
			for(int i=0;i<=Num;i++)
			{
				byte a,b,c,d;
				memcpy(&a,buf+k,1);
				k++;
				memcpy(&b,buf+k,1);
				k++;
				memcpy(&c,buf+k,1);
				k++;
				memcpy(&d,buf+k,1);
				k++;
				Rez = CTitle(a,b,c,d);
			}
		}
	  }
	}
	return Rez;
}

void CPE::SetZap(const int Num, const CTitle *Zap)
{
	CTitle Til;
	int Len = 0;
	byte LN=0;
	int k=0;
	// 
	for(int i=0;i<MatCount;i++)
	{
		memcpy(&LN,buf+6+k,1);
        k+=LN+2;
	}
    // 
	k+=9+2+4*(Num-1);
    memcpy(buf+k+0,&(Zap->A),1);
	memcpy(buf+k+1,&(Zap->B),1);
	memcpy(buf+k+2,&(Zap->C),1);
	memcpy(buf+k+3,&(Zap->D),1);
}