// LogFile.h: interface for the CLogFile class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#if !defined(AFX_LOGFILE_H__7487EF48_F2B1_4396_BD59_F30E36D605B3__INCLUDED_)
#define AFX_LOGFILE_H__7487EF48_F2B1_4396_BD59_F30E36D605B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class MPRBASE_API CLogFile
{
public:
	enum Failure {
		modeFail = 0x0000,
		modeOk   = 0x0001,
		};
	void AddLog( char*	 str, Failure msType = CLogFile::modeOk );
	void AddLog( CString str, Failure msType = CLogFile::modeOk );
	CLogFile();
	~CLogFile();
protected:
	FILE*	file;
	CString filePath;
};

extern MPRBASE_API	CLogFile*	Log;

#endif // !defined(AFX_LOGFILE_H__7487EF48_F2B1_4396_BD59_F30E36D605B3__INCLUDED_)
