// CTextureManager.h: interface for the CTextureManager class.
//
//////////////////////////////////////////////////////////////////////
#include <map>
typedef std::map<CString,GLuint> texMap;
#if !defined(AFX_CTEXTUREMANAGER_H__0D3E753A_2259_4C0C_8F8F_8E655C9ECC62__INCLUDED_)
#define AFX_CTEXTUREMANAGER_H__0D3E753A_2259_4C0C_8F8F_8E655C9ECC62__INCLUDED_
#include "ResManager.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class MPRBASE_API CTextureManager  
{
public:
	void loadTexImage( int, CString );
	rgb* GetTexImage( char*, unsigned int*,unsigned int* );
	rgb* GetTitleTexImage( int );
	void Load(CString path,GLuint*id/*, prgProc proc */);
	void Load( BYTE* data,GLuint*id/*,prgProc	proc */);
	CTextureManager();
	void setTexCount( int count );
	~CTextureManager();
	GLuint	Id;
	int	texCount;
private:
	rgb* unpack( mmpHeader mmPHeader,FILE* f );
	rgb**	textures;
};

extern MPRBASE_API CTextureManager *texMan;
#endif // !defined(AFX_CTEXTUREMANAGER_H__0D3E753A_2259_4C0C_8F8F_8E655C9ECC62__INCLUDED_)
