// mprSection.cpp: implementation of the mprSection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mprsection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
mprSection::mprSection(  )
{
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
mprSection::~mprSection()
{

}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void mprSection::Read( CString lpstrFileName/*,prgProc proc */)
{
	CFile f;
	if(! f.Open( lpstrFileName,CFile::modeRead ))
	{
		CString str;
		str.Format("section %s not found", lpstrFileName );
	}
	f.Read( &ID, 4 );
	f.Read( &water, 1 );
	ZeroMemory(mapTextures,512);
	ZeroMemory(waterTextures,512);
	memset( waterAllow,0xff,512);
	f.Read( map_points, sizeof( SSectVert )*33*33 );
	if( water != 0 )
		f.Read( water_points,sizeof( SSectVert )*33*33 );
	f.Read( mapTextures,sizeof(WORD)*16*16 );
	if( water != 0 )
	f.Read( waterTextures,sizeof(WORD)*16*16 );
	if( water != 0 )
		f.Read( waterAllow,sizeof(WORD)*16*16 );
	f.Close();
	//proc(PT_LOAD_SECTION,&f);
}

void mprSection::Write( CString lpstrFileName )
{
	CFile f;
	f.Open( lpstrFileName,CFile::modeWrite | CFile::typeBinary | CFile::modeCreate );
	f.Write( &ID, 4 );
	f.Write( &water, 1 );
	f.Write( map_points, sizeof( SSectVert )*33*33 );
	if( water != 0 )
		f.Write( water_points,sizeof( SSectVert )*33*33 );
	f.Write( mapTextures,sizeof(WORD)*16*16 );
	if( water != 0 )
	{
		f.Write( waterTextures,sizeof(WORD)*16*16 );
		f.Write( waterAllow,sizeof(WORD)*16*16 );
	}
	f.Close();
}
