#if !defined(CCAMEDIT_H)
#define CCAMEDIT_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CPlugin.h : header file
//
//#include "gameTypes.h"
//#include <mprbase.h>
#include <EIPlugin\CPlugin_base.h>
#include <commdlg.h>
#define PLUGIN_API 	extern "C" _declspec(dllexport)
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog

class Ccamedit : public CPlugin
{
// Construction
public:
	Ccamedit( );   // standard constructor
	virtual ~Ccamedit();
	virtual void Create( CWnd* );

	virtual void onMouseMove    ( UINT nFlags, CPoint point );
	virtual void onRButtonDown  ( UINT nFlags, CPoint point );
	virtual void onLButtonDown  ( UINT nFlags, CPoint point );
	virtual void onRButtonUp (UINT nFlags, CPoint point);
	virtual void onLButtonUp (UINT nFlags, CPoint point);
	virtual void onLButtonDblClk( UINT nFlags, CPoint point );
	virtual void onRButtonDblClk( UINT nFlags, CPoint point );
	virtual void onMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	virtual	void onPluginSelect();
	virtual	void onPluginUnSelect();
	virtual void display();
	virtual HICON getIcon();

	void ExportZap();
	void ImportZap();

	void LoadFile();
	  //Interface *ip;
	  
	void SaveFile();
	void ShowView();
	void SetView();
	void PlayFile();
	void ShowNextZap();
	byte *Buffer;

	//Camera
	void Apply();
	void ShowPrev();
	void ShowNext();
	void NewZap();
	void RemoveZap();
	void Offset(byte *buf,int len, int from, int to, float X,float Y,float Z);

	void Test();
	CWnd *handle;
	CWnd *GetHandle();

	//HWND PluginWindowHandle;


	//     
	//-
	vec3 Coordinates;
	quat Orientation;
	bool FileOpened;

	//
	int GetRange(bool First,bool From);
	bool IsInRange(int RangeMin, int RangeMax, int Num);
	bool IsRangeCorrect(int RangeMin, int RangeMax);
	byte *Delete(byte *buf, int len, int start, int count);
	byte *Move(vec3 Start,quat ViewS, vec3 End, quat ViewE, float Time, int ZapNum, bool IsMove, bool IsRotate);
	byte *Cut(byte *buf, int len, int start, int count);
	byte *Paste(byte *buf1, byte *buf2, int len1,int len2, int start);
	byte *FillBlock(float Time,float Unknown,float X,float Y,float Z,float qW,float qX,float qY,float qZ);
	void Swap(byte *buf, int len, int Start1, int Count1, int Start2, int Count2);
	void Invert(byte *buf, int len);
	void BtnOffset();

public:
	vec3	oldPos;
	vec3	oldLPos;
	vec3	sp,view;
	float	HA,VA,YA,len;
	CPoint	start;
private:
// Dialog Data
	//{{AFX_DATA(CPlugin)
	enum { IDD = IDD_PLUGIN };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlugin)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPlugin)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnStnClickedQuatxst();
	afx_msg void OnBnClickedInverse();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBnClickedBtnExtended();
	afx_msg void OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnBnClickedSaveCoords();
	afx_msg void OnBnClickedSaveView();
	afx_msg void OnBnClickedBtnSwap();
	afx_msg void OnBnClickedBtnInverce();
	afx_msg void OnBnClickedBtnMove();
	afx_msg void OnBnClickedBtnRotate();
	afx_msg void OnBnClickedBtnPointLook();
	afx_msg void OnBnClickedBtnTrack();
	afx_msg void OnBnClickedBtnTime();
};

PLUGIN_API	CPlugin*	getPlugin( );
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(CCAMEDIT_H)
