// CPlugin.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Cpickpoint.h"

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif
#include "resource.h"
Cpickpoint	plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog

void Cpickpoint::Create( CWnd* pParentWnd )
{
	CDialog::Create( Cpickpoint::IDD, pParentWnd );

	tip = "Single point picker";
	map = NULL;
	icon = AfxGetApp()->LoadIcon(IDI_ICON1);
}
Cpickpoint::Cpickpoint()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(Cpickpoint)
	//}}AFX_DATA_INIT
}


void Cpickpoint::DoDataExchange(CDataExchange* pDX)
{
	CPlugin::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Cpickpoint)
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(Cpickpoint, CPlugin)
	//{{AFX_MSG_MAP(Cpickpoint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void Cpickpoint::onMouseMove    ( UINT nFlags, CPoint point )
{
	vec3 vs;
	vs = map->selectionRay( nFlags, point );
	sp = map->findSelect( vs );

};
void Cpickpoint::onRButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 n;
	n = map->findNearest(sp);
	map->setHMapZ( n.x,n.y,map->getHMapZ(n.x,n.y)-1000 );
	map->refresh();
};
void Cpickpoint::onLButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 n;
	n = map->findNearest(sp);
	map->setHMapZ( n.x,n.y,map->getHMapZ(n.x,n.y)+1000 );
	map->refresh();
};
void Cpickpoint::onLButtonUp  ( UINT nFlags, CPoint point )
{
};
void Cpickpoint::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void Cpickpoint::onRButtonDblClk( UINT nFlags, CPoint point )
{
};
/////////////////////////////////////////////////////////////////////////////
// Cpickpoint message handlers
CPlugin*	getPlugin( )
{
	return &plugin;
}

void Cpickpoint::onPluginSelect()
{
}

void Cpickpoint::onPluginUnSelect()
{
}

void Cpickpoint::display()
{
	int x,y;
	vec3 n;
	n = map->findNearest(sp);
	x = (int)n.x;
	y = (int)n.y;
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
		glColor3f(1,0,0);
		glBegin(GL_LINES);
			glVertex3f((float)x,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y )));
			glVertex3f((float)x-1,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x-1,y )));

			glVertex3f((float)x,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y )));
			glVertex3f((float)x,(float)y-1,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y-1 )));

			glVertex3f((float)x,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y )));
			glVertex3f((float)x+1,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x+1,y )));

			glVertex3f((float)x,(float)y,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y )));
			glVertex3f((float)x,(float)y+1,(float)map->getvZoom()/65535.0f*(map->getHMapZ( x,y+1 )));
			glEnd();
		glColor3f(1,1,1);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
}

void Cpickpoint::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
}

void Cpickpoint::onRButtonUp( UINT nFlags, CPoint point )
{
}

HICON Cpickpoint::getIcon()
{
	return NULL;
}
