// CPlugin.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Cwater_edit.h"
#include <EIplugin\cplugin_base.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "resource.h"
CWaterEdit plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog


CWaterEdit::CWaterEdit()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CWaterEdit)
	//}}AFX_DATA_INIT
	color.r = 64;
	color.g = 64;
	color.b = 255;
}


void CWaterEdit::DoDataExchange(CDataExchange* pDX)
{
	CPlugin::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaterEdit)
	DDX_Control(pDX, IDC_LIST1, m_OperationsList);
	//}}AFX_DATA_MAP
}

void CWaterEdit::Create( CWnd* pParentWnd )
{
	this->pParentWnd = (CFrameWnd*)pParentWnd;
	CDialog::Create( CWaterEdit::IDD, pParentWnd );
	tip = "Water edit";
	icon = AfxGetApp()->LoadIcon(IDI_ICON1);


}

BEGIN_MESSAGE_MAP(CWaterEdit, CPlugin)
	//{{AFX_MSG_MAP(CWaterEdit)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CWaterEdit::onMouseMove    ( UINT nFlags, CPoint point )
{
	if( GetAsyncKeyState(VK_LBUTTON) && sp.x != -1000 )
	{
		vec3 vs,_ep;
		vs = map->selectionRay( nFlags, point );
		_ep = map->findSelectWater( vs );
		if( _ep.x != -1000 ) 
		{
			ep = _ep;
			ep.x = (int)ep.x/2*2;
			ep.y = (int)ep.y/2*2;		}
	}
};
void CWaterEdit::onRButtonDown  ( UINT nFlags, CPoint point )
{
};
void CWaterEdit::onLButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 vs;
	vs = map->selectionRay( nFlags, point );
	sp = map->findSelectWater( vs );
	sp.x = (int)sp.x/2*2;
	sp.y = (int)sp.y/2*2;
	ep = sp;
	if(((CButton*)GetDlgItem(IDC_RADIO1))->GetState() == 1)
	{
		sWCells.clear();
		if( sp.x != -1000 )
		{
			AddTitleToSelection( (int)sp.x/2*2,(int)sp.y/2*2 );
		}
	
	}
	if(((CButton*)GetDlgItem(IDC_RADIO2))->GetState() == 1)
	{
		if( sp.x != -1000 )
		{
			CWaterQuadro q;
			q.x = (int)sp.x/2*2;
			q.y = (int)sp.y/2*2;
			InvertST( (int)sp.x/2*2,(int)sp.y/2*2 );
		}
	}
	if(((CButton*)GetDlgItem(IDC_RADIO3))->GetState() == 1)
	{
	
	}
};
void CWaterEdit::onLButtonUp  ( UINT nFlags, CPoint point )
{
	if(((CButton*)GetDlgItem(IDC_RADIO3))->GetState() == 1)
	{
		switch ( m_OperationsList.GetCurSel() )
		{
			case 0:Union();break;
			case 1:Intersection();break;
			case 2:Substraction();break;
		}
	}
};
void CWaterEdit::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void CWaterEdit::onRButtonDblClk( UINT nFlags, CPoint point )
{
};
/////////////////////////////////////////////////////////////////////////////
// CWaterEdit message handlers
CPlugin*	getPlugin( )
{
	return &plugin;
}

void CWaterEdit::onPluginSelect()
{
}

void CWaterEdit::onPluginUnSelect()
{
}

void CWaterEdit::display()
{
	static int dx=1;
	if(color.r == 192) dx = -1;
	if(color.r == 064) dx =  1;
		color.r+=dx;
		color.g+=dx;
	SET::iterator it;
	int x,y;
	glDisable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	glColor3ubv(&color.r);
	for( it = sWCells.begin(); it != sWCells.end(); it++ )
	{
		int size = sWCells.size();
		x = (*it).x;y=(*it).y;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));

		x = (*it).x+1;y=(*it).y;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+2;y=(*it).y;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+2;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));

		x = (*it).x;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y+2;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x;y=(*it).y+2;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));

		x = (*it).x+1;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+2;y=(*it).y+1;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+2;y=(*it).y+2;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
		x = (*it).x+1;y=(*it).y+2;
		glVertex3f( x, y,map->scaleZ(map->getWMapZ( x, y )));
	}
	glEnd();
	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);
	if( ((CButton*)GetDlgItem(IDC_RADIO3))->GetState() == 1 &&
		GetAsyncKeyState(VK_LBUTTON) )
	{
		int x1,y1,x2,y2,i;

		x1 = min( sp.x,ep.x );
		x2 = max( sp.x,ep.x );
		y1 = min( sp.y,ep.y );
		y2 = max( sp.y,ep.y );

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);
		glColor3f(1,1,1);
		glBegin(GL_LINE_STRIP);
		for(i=x1;i<x2;i++)
			glVertex3f(i,y1,map->scaleZ(map->getWMapZ( i, y1 )));
		for(i=y1;i<y2;i++)
			glVertex3f(x2,i,map->scaleZ(map->getWMapZ( x2, i )));
		for(i=x2;i>x1;i--)
			glVertex3f(i,y2,map->scaleZ(map->getWMapZ( i, y2 )));
		for(i=x2;i>y1;i--)
			glVertex3f(x1,i,map->scaleZ(map->getWMapZ( x1, i )));
		glEnd();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_DEPTH_TEST);
	}

}

void CWaterEdit::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
}
BOOL CWaterEdit::OnInitDialog() 
{
	CPlugin::OnInitDialog();
	m_OperationsList.AddString("Union");
	m_OperationsList.AddString("Intersection");
	m_OperationsList.AddString("Substraction");
	((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck( 1 );
	m_OperationsList.SetCurSel( 0 );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWaterEdit::AddTitleToSelection( int x,int y )
{

	ScanLine( x, y );
}

bool CWaterEdit::ScanLine( int x,int y )
{
	CWaterQuadro q;
	q.x = x;q.y = y;
	if( (sWCells.end() == sWCells.find(q)) && 
		(y >= 0) && (y + 2< map->getMapYDimension( )) &&
		((map->getObjectID(x/2,y/2) != 0xffff)))
	{
		int i,xmin,xmax;
		i = x;
		while( (map->getObjectID(i/2,y/2) != 0xffff) && i >= 0 )	
		{
			q.x = i;q.y = y;
			sWCells.insert( q );
			i-=2;
		}
		xmin = i;
		i = x+2;
		while( (map->getObjectID(i/2,y/2) != 0xffff) && (i + 2 < map->getMapXDimension( )) )
		{
			q.x = i;
			q.y = y;
			sWCells.insert( q );
			i+=2;
		}
		xmax = i;
		for( i=xmin;i<xmax;i+=2 )
		{
			ScanLine( i, y-2 );
			ScanLine( i, y+2 );
		}
		return true;
	}
	return false;
}

bool CWaterEdit::InvertST( int x,int y )
{
	CWaterQuadro q;
	q.x = x;
	q.y = y;
	if( sWCells.end() == sWCells.find(q) )
		sWCells.insert(q);
	else
		sWCells.erase(sWCells.find(q));
	return true;
}

void CWaterEdit::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	m_OperationsList.ModifyStyle(WS_DISABLED , 0);
}

void CWaterEdit::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	m_OperationsList.ModifyStyle(0,WS_DISABLED);
}

void CWaterEdit::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	m_OperationsList.ModifyStyle(0,WS_DISABLED);
}

void CWaterEdit::Union()
{
	int x1,y1,x2,y2,i,j;
	CWaterQuadro q;
	
	x1 = min( sp.x,ep.x );
	x2 = max( sp.x,ep.x );
	y1 = min( sp.y,ep.y );
	y2 = max( sp.y,ep.y );
	for( i=x1;i<x2;i+=2 )
	for( j=y1;j<y2;j+=2 )
	{
		q.x = i;
		q.y = j;
		sWCells.insert(q);
	}
}


void CWaterEdit::Intersection()
{
	int x1,y1,x2,y2,x,y;
	CWaterQuadro q;
	SET::iterator it;
	VEC	vec;
	vec.clear();
	x1 = min( sp.x,ep.x );
	x2 = max( sp.x,ep.x );
	y1 = min( sp.y,ep.y );
	y2 = max( sp.y,ep.y );
	for( it = sWCells.begin();it != sWCells.end();it++ )
	{
		x = (*it).x;
		y = (*it).y;
		if( !(x >= x1 && x < x2 && y >= y1 && y < y2) )
		vec.push_back(it);
	}
	for( int i=0;i<vec.size();i++ )
		sWCells.erase(vec[i]);
	vec.clear();
}
void CWaterEdit::Substraction()
{
	int x1,y1,x2,y2,x,y;
	CWaterQuadro q;
	SET::iterator it;
	VEC	vec;
	vec.clear();
	x1 = min( sp.x,ep.x );
	x2 = max( sp.x,ep.x );
	y1 = min( sp.y,ep.y );
	y2 = max( sp.y,ep.y );
	for( it = sWCells.begin();it != sWCells.end();it++ )
	{
		x = (*it).x;
		y = (*it).y;
		if( x >= x1 && x < x2 && y >= y1 && y < y2 )
		vec.push_back(it);
//			sWCells.erase(it);
	}
	for( int i=0;i<vec.size();i++ )
		sWCells.erase(vec[i]);
	vec.clear();

}

void CWaterEdit::onRButtonUp (UINT nFlags, CPoint point)
{
}


HICON CWaterEdit::getIcon()
{
	return NULL;
}