// CPlugin.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Cwater_select.h"
#include <EIplugin\cplugin_base.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "resource.h"
CWaterSelect	plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog


CWaterSelect::CWaterSelect()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CWaterSelect)
	//}}AFX_DATA_INIT
}


void CWaterSelect::DoDataExchange(CDataExchange* pDX)
{
	CPlugin::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaterSelect)
	//}}AFX_DATA_MAP
}

void CWaterSelect::Create( CWnd* pParentWnd )
{
	this->pParentWnd = (CFrameWnd*)pParentWnd;
	CDialog::Create( CWaterSelect::IDD, pParentWnd );
	tip = "Water select";
	icon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

BEGIN_MESSAGE_MAP(CWaterSelect, CPlugin)
	//{{AFX_MSG_MAP(CWaterSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CWaterSelect::onMouseMove    ( UINT nFlags, CPoint point )
{
	vec3 vs;
	vs = map->selectionRay( nFlags, point );
	sp = map->findSelect( vs );

};
void CWaterSelect::onRButtonDown  ( UINT nFlags, CPoint point )
{
};
void CWaterSelect::onLButtonDown  ( UINT nFlags, CPoint point )
{
	x = ((int)sp.x)/2*2;
	y = ((int)sp.y)/2*2;
	if( x<10 ) x=10;
	if( y<10 ) y=10;
	if( x>(int)map->getMapXDimension()-11 ) x = (int)map->getMapXDimension()-11;
	if( y>(int)map->getMapYDimension()-11 ) y = (int)map->getMapYDimension()-11;
	wgD = new CWaterGridDialog();
	wgD->DoModal(map,x,y);
};
void CWaterSelect::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void CWaterSelect::onRButtonDblClk( UINT nFlags, CPoint point )
{
};
/////////////////////////////////////////////////////////////////////////////
// CWaterSelect message handlers
CPlugin*	getPlugin( )
{
	return &plugin;
}

void CWaterSelect::onPluginSelect()
{
}

void CWaterSelect::onPluginUnSelect()
{
}

void CWaterSelect::display()
{
	x = ((int)sp.x)/2*2;
	y = ((int)sp.y)/2*2;
	if( x<10 ) x=10;
	if( y<10 ) y=10;
	if( x>(int)map->getMapXDimension()-11 ) x = (int)map->getMapXDimension()-11;
	if( y>(int)map->getMapYDimension()-11 ) y = (int)map->getMapYDimension()-11;
	glDisable( GL_TEXTURE_2D );
	glDisable( GL_DEPTH_TEST );
	glPolygonMode( GL_FRONT, GL_LINE );
		int i,j;
		glColor3f(1,0,0);
		glBegin( GL_LINE_STRIP );
		j = y-10;
		for( i=x-10;i<x+10;i++ )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);	
		i = x+10;
		for( j=y-10;j<y+10;j++ )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		j = y+10;
		for( i=x+10;i>x-10;i-- )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		i = x-10;
		for( j=y+10;j>y-10;j-- )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		glEnd();
		glColor3f(1,1,1);
	glPolygonMode( GL_FRONT, GL_FILL );
	glEnable( GL_TEXTURE_2D );
	glEnable( GL_DEPTH_TEST );
}

void CWaterSelect::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
}
BOOL CWaterSelect::OnInitDialog() 
{
	CPlugin::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWaterSelect::onRButtonUp( UINT nFlags, CPoint point )
{
}

void CWaterSelect::onLButtonUp ( UINT nFlags, CPoint point )
{
}

HICON CWaterSelect::getIcon()
{
	return NULL;
}