#if !defined(AFX_WATERGRIDDIALOG_H__9A4647AF_4868_4C57_9A2B_673B2A74C685__INCLUDED_)
#define AFX_WATERGRIDDIALOG_H__9A4647AF_4868_4C57_9A2B_673B2A74C685__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WaterGridDialog.h : header file
//
#include "resource.h"
#define	GRID_EDGE 470
#define STEP GRID_EDGE/10
/////////////////////////////////////////////////////////////////////////////
// CWaterGridDialog dialog

class CWaterGridDialog : public CDialog
{
// Construction
public:
	CWaterGridDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CWaterGridDialog)
	enum { IDD = IDD_WATER_GRID_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	CStatic*	grid;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWaterGridDialog)
	public:
	virtual int DoModal( CmprLandscape*,int, int);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int	centerCellX,centerCellY;
	int	selectedCellX,selectedCellY;
	CmprLandscape * map;
	WORD	titles[10][10];
protected:
	// Generated message map functions
	//{{AFX_MSG(CWaterGridDialog)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedGridRect();
	afx_msg void OnBnClickedBtnFill();
	afx_msg void OnBnClickedInvert();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WATERGRIDDIALOG_H__9A4647AF_4868_4C57_9A2B_673B2A74C685__INCLUDED_)
